// CellAverageObserver.h: interface for the CellAverageObserver class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ELLAVERAGEOBSERVER_H__DA41A943_25CF_11D4_8694_00A0C9B3BB18__INCLUDED_)
#define AFX_ELLAVERAGEOBSERVER_H__DA41A943_25CF_11D4_8694_00A0C9B3BB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <assert.h>
#include "ReactionMover.h"
#include "ReactionNetwork.h"
#include "SubjectObserver.h"

class CellAverageObserver : public Observer  
{
public:
	void ZeroConcentrations();
	CellAverageObserver(int numberOfChemicals, int numberOfTimeSteps, int numberOfCells);
	virtual ~CellAverageObserver();
	void Update(Subject *theChangedSubject);

	const double **GetAverageConcentration() const {return (const double **)averageConcentration;}
	const int GetNumberOfTimeSteps() const {return numberOfTimeSteps;}
	const int GetNumberOfCells() const {return numberOfCells;}
private:
	int numberOfChemicals;
	int numberOfTimeSteps;
	int numberOfCells;
	double **averageConcentration;

};

#endif // !defined(AFX_ELLAVERAGEOBSERVER_H__DA41A943_25CF_11D4_8694_00A0C9B3BB18__INCLUDED_)
