// Chemical.cpp: implementation of the Chemical class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _WINDOWS
#include "stdafx.h"
#endif

#include "Chemical.h"
#include <vector>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Chemical::Chemical(int chemicalNumber, double amount, std::string name)
{
	this->chemicalNumber = chemicalNumber;
	SetAmount(amount);
	initialAmount = amount;
	if(initialAmount > 0.0 )
	{
		errorInInitialAmount = initialAmount;
	}
	else
	{	
		errorInInitialAmount = 1.0;
	}
	this->name = name;
	this->SetTeXName();
}

Chemical::Chemical(int chemicalNumber, double amount, double errorInInitialAmount, std::string name)
{
	this->chemicalNumber = chemicalNumber;
	SetAmount(amount);
	initialAmount = amount;
	this->errorInInitialAmount = errorInInitialAmount;
	this->name = name;
	this->SetTeXName();
}

Chemical::Chemical()
{

}

Chemical::~Chemical()
{

}

double Chemical::GetAmount() const
{
	return amount;
}

double Chemical::GetInitialAmount() const
{
	return initialAmount;
}

double Chemical::GetErrorInInitialAmount() const
{
	return errorInInitialAmount;
}

void Chemical::SetInitialAmount(double initialAmount)
{
	this->initialAmount = initialAmount;
}

void Chemical::SetErrorInInitialAmount(double errorInInitialAmount)
{
	this->errorInInitialAmount = errorInInitialAmount;
}

const std::vector<Reaction *> *Chemical::GetReactions() const
{
	return &reactions;
}

void Chemical::IncrementAmount(double change)
{
	amount += change;
}

void Chemical::SetAmount(double amount)
{
	this->amount = amount;
}

void Chemical::Reset()
{
	SetAmount(initialAmount);
}

std::string Chemical::GetName() const
{
	return name;
}

int Chemical::GetChemicalNumber()
{
	return chemicalNumber;
}

void Chemical::SetTeXName()
{
	// parse the name string into a TeX string
	strstream stream;
	// make sure name does not appear in italics
	stream << "{\\mathrm{";
	// write remaining characters into name array
	for(int i = 0; i < name.size(); i++)
	{
		stream << name[i];
	}
	// now close the subscript bracket, along with a null character
	stream << "}}" << ends;
	// set the TeX string equal to what's in the stream
	m_sTeXName = stream.str();
	// allow deletion of the stream
	stream.rdbuf()->freeze(0);
}