// Chemical.h: interface for the Chemical class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHEMICAL_H__17E9EE5E_DB43_11D3_8099_00A0C9B3BB18__INCLUDED_)
#define AFX_CHEMICAL_H__17E9EE5E_DB43_11D3_8099_00A0C9B3BB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include <string.h>
#include <strstrea.h>
#include "Reaction.h"

class Reaction;	// Both files refer to one another

class Chemical  
{
public:	
	std::string GetName() const;
	std::string GetTeXName() const {return m_sTeXName;}
	Chemical();
	Chemical(int chemicalNumber, double amount=0, std::string name="");
	Chemical(int chemicalNumber, double amount, double errorInInitialAmount, std::string name);
	virtual ~Chemical();
	double GetAmount() const;
	double GetInitialAmount() const;
	double GetErrorInInitialAmount() const;
	virtual void SetErrorInInitialAmount(double errorInInitialAmount);
	virtual void SetAmount(double amount);
	virtual void SetInitialAmount(double initialAmount);
	virtual void IncrementAmount(double change);
	virtual void Reset();
	const std::vector<Reaction *> *GetReactions() const;
	int GetChemicalNumber();
	void SetTeXName();
protected:
	int chemicalNumber;	// In the array of all chemicals, which one am I?
	std::vector<Reaction *> reactions;	// Reactions that depend or affect the chemical
	double amount;			// current amount of chemical
	double initialAmount;	// initial amount of chemical
	double errorInInitialAmount; // uncertainty in initial amount
	std::string name;
	std::string m_sTeXName;
};

#endif // !defined(AFX_CHEMICAL_H__17E9EE5E_DB43_11D3_8099_00A0C9B3BB18__INCLUDED_)
