// CompetitiveDegradationReaction.cpp: implementation of the CompetitiveDegradationReaction class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _WINDOWS
#include "stdafx.h"
#endif

#include "CompetitiveDegradationReaction.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CompetitiveDegradationReaction::CompetitiveDegradationReaction(Chemical *phosphorylatedprotein, Chemical *competitivebinder, 
												 RateConstant *kphx, RateConstant *Km, std::string CompetitiveDegradationReaction)
{
	int numChemicals = 0;

	chemicals.push_back(phosphorylatedprotein);
	this->phosphorylatedprotein = numChemicals;	// Number in private array
	numChemicals++;
	numberOfEachChemicalChangedByReaction.push_back(-1);

	chemicals.push_back(competitivebinder);
	this->competitivebinder = numChemicals;
	numChemicals++;
	numberOfEachChemicalChangedByReaction.push_back(0);

	int numRateConstants = 0;

	rateConstants.push_back(kphx);
	this->kphx = numRateConstants;
	numRateConstants++;

	rateConstants.push_back(Km);
	this->Km = numRateConstants;
	numRateConstants++;

	this->SetTeXForm();
}

CompetitiveDegradationReaction::~CompetitiveDegradationReaction()
{

}


double CompetitiveDegradationReaction::GetRate() const
{
	return rateConstants[kphx]->GetValue() * chemicals[phosphorylatedprotein]->GetAmount()/( rateConstants[Km]->GetValue() + chemicals[phosphorylatedprotein]->GetAmount() + chemicals[competitivebinder]->GetAmount());
}

void CompetitiveDegradationReaction::SetTeXForm() 
{
	return;
}

// TEMPORARY

std::vector<Reaction::JElement *> *CompetitiveDegradationReaction::GetChemicalJacobian()
{
	return &chemicalJacobian;
}
