// ompetitiveDegradationReaction.h: interface for the CompetitiveDegradationReaction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OMPETITIVEDEGRADATIONREACTION_H__95541F7D_E7E7_11D3_807F_00A0C9B3BAEA__INCLUDED_)
#define AFX_COMPETITIVEDEGRADATIONREACTION_H__95541F7D_E7E7_11D3_807F_00A0C9B3BAEA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Reaction.h"

class CompetitiveDegradationReaction : public Reaction  
{
public:
	double GetRate() const;
	CompetitiveDegradationReaction(Chemical *phosphorylatedprotein, Chemical *competitivebinder, RateConstant *kphx, RateConstant *Km, std::string name);
	virtual ~CompetitiveDegradationReaction();
	std::vector<JElement *> *GetChemicalJacobian();
	void SetTeXForm();
private:
	int phosphorylatedprotein, competitivebinder;	// Local integer variables denoting place of various chemicals on the local chemical list
	int kphx, Km;		// Local integer variables d


};

#endif // !defined(AFX_COMPETITIVEDEGRADATIONREACTION_H__95541F7D_E7E7_11D3_807F_00A0C9B3BAEA__INCLUDED_)


