// DataPoint.h: interface for the DataPoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATAPOINT_H__CC6D0924_2676_11D4_8695_00A0C9B3BB18__INCLUDED_)
#define AFX_DATAPOINT_H__CC6D0924_2676_11D4_8695_00A0C9B3BB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// comparator compares pointers to data points, which we need 
// to be able to sort ChemicalTimeSeriesData

class DataPoint  
{
public:
	DataPoint(double time=0.0, double datum=0.0, double error=0.0);
	virtual ~DataPoint();
	void RescaleTime(double scaleFac);
	void RescaleDatum(double scaleFac);
	void RescaleError(double scaleFac);
	double GetTime() const {return time;}
	double GetDatum() const {return datum;}
	double GetError() const {return error;}
	void SetTime(double time) {this->time = time;}
	void SetDatum(double datum) {this->datum = datum;}
	void SetError(double error) {this->error = error;}
	class DataPointComparator
	{
	public:
		DataPointComparator() {return;}
		virtual ~DataPointComparator() {return;}
		bool operator()(DataPoint *d1, DataPoint *d2) 
		{
			return d1->GetTime() < d2->GetTime();
		}
	};
private:
	double time;
	double datum;
	double error;
};

#endif // !defined(AFX_DATAPOINT_H__CC6D0924_2676_11D4_8695_00A0C9B3BB18__INCLUDED_)
