// DifferentialEquationMover.h: interface for the DifferentialEquationMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DIFFERENTIALEQUATIONMOVER_H__9C9D6A4F_D52C_47A0_A824_77A59D8026CC__INCLUDED_)
#define AFX_DIFFERENTIALEQUATIONMOVER_H__9C9D6A4F_D52C_47A0_A824_77A59D8026CC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iomanip.h>
#include <cmath>
#include "..\SRC\ReactionMover.h"

class CDifferentialEquationMover : public CReactionMover  
{
public:
	CDifferentialEquationMover();
	CDifferentialEquationMover(double frequency, double stepSize);
	virtual ~CDifferentialEquationMover();
	void ComputeDerivatives(double *chem, double *dChemdt);	
	void ComputeJacobian(double *chem, double **dRHSdChem);
	virtual double GetStepSize() const {return m_dStepSize;}
	virtual void SetStepSize(double newSize);
	virtual void ResetStepSize();
	virtual void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork) = 0;
protected:
	double m_dStepSize;
	double m_dDefaultStepSize;
};

#endif // !defined(AFX_DIFFERENTIALEQUATIONMOVER_H__9C9D6A4F_D52C_47A0_A824_77A59D8026CC__INCLUDED_)
