// EnsembleMember.cpp: implementation of the CEnsembleMember class.
//
//////////////////////////////////////////////////////////////////////

#include "EnsembleMember.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
	
CEnsembleMember::CEnsembleMember(int nParameters, double *parameters, int nResiduals, double *residuals, double quadratic, double cost) 
{
	m_iPSize = nParameters;
	m_iRSize = nResiduals;
	m_pdParameters = new double[nParameters];
	m_pdResiduals = new double[nResiduals];
	for(int i = 0; i < m_iPSize; i++)
	{
		m_pdParameters[i] = parameters[i];
	}
	for(i = 0; i < m_iRSize; i++)
	{
		m_pdResiduals[i] = residuals[i];
	}
	m_dQuadratic = quadratic;
	m_dCost = cost;
	return;
}

CEnsembleMember::~CEnsembleMember()
{
	delete [] m_pdParameters;
	delete [] m_pdResiduals;
}
