// EnsembleMember.h: interface for the CEnsembleMember class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENSEMBLEMEMBER_H__5E580F5F_E972_4FFE_A9F3_842C924D9C8A__INCLUDED_)
#define AFX_ENSEMBLEMEMBER_H__5E580F5F_E972_4FFE_A9F3_842C924D9C8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEnsembleMember  
{
public:
	CEnsembleMember(int nParameters, double *parameters, int nResiduals, double *residuals, double quadratic, double cost);
	virtual ~CEnsembleMember();
	int GetParameterSize() {return m_iPSize;}
	int GetResidualsSize() {return m_iRSize;}
	double GetParameter(int parIndex) {return m_pdParameters[parIndex];}
	double GetResidual(int resIndex) {return m_pdResiduals[resIndex];}
	double GetQuadratic() {return m_dQuadratic;}
	double GetCost() {return m_dCost;}
private:
	int m_iPSize;
	int m_iRSize;
	double *m_pdParameters;
	double *m_pdResiduals;
	double m_dQuadratic;
	double m_dCost;
};

#endif // !defined(AFX_ENSEMBLEMEMBER_H__5E580F5F_E972_4FFE_A9F3_842C924D9C8A__INCLUDED_)
