// Experiment.h: interface for the Experiment class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXPERIMENT_H__0C8658DA_AB00_4608_A352_7200321D66D1__INCLUDED_)
#define AFX_EXPERIMENT_H__0C8658DA_AB00_4608_A352_7200321D66D1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// this turns off template inside template warnings - should be in a common
// header file
#pragma warning(disable:4786)

#include <stdexcept>
#include <vector>
#include "ReactionNetwork.h"
#include "ChemicalTimeSeriesData.h"
#include "../src_ac/ForcingData.h"

class Experiment  
{
public:
	Experiment(ReactionNetwork *reactionNetwork,std::string experimentName="");
	virtual ~Experiment();
	void AddDataFileToList(std::string fileName);
	void AddForcingFileToList(std::string fileName);
	void ReadData();
	void ReadForcingData();
	std::string GetExperimentName() const {return _experimentName;}
	ReactionNetwork* GetReactionNetwork() {return _reactionNetwork;}
	ChemicalTimeSeriesData* GetChemicalTimeSeriesData() {return _data;}
	CForcingData* GetForcingData() {return _forcingData;}
private:
	std::string _experimentName;
	std::vector<std::string> _fileList;
	std::vector<std::string> _forcingFileList;
	ReactionNetwork* _reactionNetwork;
	ChemicalTimeSeriesData* _data;
	CForcingData* _forcingData;
};

#endif // !defined(AFX_EXPERIMENT_H__0C8658DA_AB00_4608_A352_7200321D66D1__INCLUDED_)
