// This plotting program courtesy of M. Rauscher, modifications by K. S. Brown
//		Any derived class of GnuPlotter must overload Update, even
//	if (as in the example of a one-time plot) you don't use it.

#ifndef GNUPLOTTER_H
#define GNUPLOTTER_H

#include <iostream.h>
#include <stdio.h>
#include "SubjectObserver.h"

class GnuPlotter : public Observer
{
	protected:
		char title[256];
		char *buffername;
		FILE* gnuplot_pipe;
		FILE* buffer;
	public:
		virtual bool SetTitle(const char * text) 
		{ 
			#ifdef _DEBUG 
				if (strlen(text)>=255) return(false);
			#endif
			strcpy(title, text);
			return(true);
		}
#ifndef SWIG
		GnuPlotter(void);
		GnuPlotter(FILE * gplotpipe);
		virtual ~GnuPlotter(void);

		// virtual bool InitializeGnuplot(void)=0;
		virtual bool FlushGnuPlotter(void) 
		{ 
			#ifdef _DEBUG
				if (gnuplot_pipe==NULL) return(false);
			#endif 
			fflush(gnuplot_pipe);
			return(true);
		};
		virtual bool SendPlotCommand(const char* commandstring);
		virtual void Update(Subject *theChangedSubject) = 0;
#endif // SWIG
};
#endif