// LeastSquaresObserver.cpp: implementation of the LeastSquaresObserver class.
//
//////////////////////////////////////////////////////////////////////

#include "LeastSquaresObserver.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLeastSquaresObserver::CLeastSquaresObserver()
{

}

CLeastSquaresObserver::~CLeastSquaresObserver()
{

}

// default behavior is to print plain text matrix seperated by single spaces

void CLeastSquaresObserver::Update(Subject *theChangedSubject)
{
	int i;
	int j;
	int NParameters;
	int m_iNResiduals;
	// static cast may be dangerous
	CLeastSquaresMinimizer *LSM = (CLeastSquaresMinimizer *)theChangedSubject;

	// write the experimental data to the temporary file
	fstream *forcefile = new fstream("LSForceMatrix.dat",ios::out);

	const double **m_pdForceMatrix = LSM->GetForceMatrix();
	NParameters = LSM->GetNParameters();
	m_iNResiduals = LSM->GetNResiduals();
	for (i=0; i < NParameters; i++) {
		for (j=0; j < m_iNResiduals; j++) {
			*forcefile << m_pdForceMatrix[i][j] << " ";
			//cout << LSM->GetForceMatrix()[i][j] << " ";
	    }
	    *forcefile << endl;
		//cout << endl;
	}

	delete forcefile;

	return;

}
