// LogChemical.cpp: implementation of the CLogChemical class.
//
//////////////////////////////////////////////////////////////////////

#include "LogChemical.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLogChemical::CLogChemical(int chemicalNumber, std::string name, std::vector<Chemical *> chemRefVector)
:CAlgebraicChemical(chemicalNumber,name,chemRefVector)
{

}

CLogChemical::~CLogChemical()
{

}

void CLogChemical::ComputeAmount()
{
	double temp = 0.0;
	for(int i = 0; i < m_vpChemRefVector.size(); i++)
	{
		temp += m_vpChemRefVector[i]->GetAmount();
	}
	amount = log(temp);
}

void CLogChemical::ComputeInitialAmount()
{
	double temp = 0.0;
	for(int i = 0; i < m_vpChemRefVector.size(); i++)
	{
		temp += m_vpChemRefVector[i]->GetInitialAmount();
	}
	initialAmount = log(temp);
}

void CLogChemical::ComputeErrorInInitialAmount()
{
	double temp = 0.0;
	double error;
	double valuesum = 0.0;
	for(int i = 0; i < m_vpChemRefVector.size(); i++)
	{
		error = m_vpChemRefVector[i]->GetErrorInInitialAmount();
		valuesum += m_vpChemRefVector[i]->GetInitialAmount();
		temp += error*error;
	}
	errorInInitialAmount = sqrt(temp)/valuesum;
}