// MatrixOperations.cpp: implementation of the CMatrixOperations class.
//
//////////////////////////////////////////////////////////////////////

#include "MatrixOperations.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMatrixOperations::CMatrixOperations()
{

}

CMatrixOperations::~CMatrixOperations()
{

}

double CMatrixOperations::DotProduct(double *v1, double *v2, int size)
{
	double sum = 0.0;
	for(int i = 0; i < size; i++)
	{
		sum += v1[i]*v2[i];
	}
	return sum;
}

double CMatrixOperations::VectorL2Norm(double *v, int size)
{
	double norm = 0.0;
	for(int i = 0; i < size; i++)
	{
		norm += v[i]*v[i];
	}
	return sqrt(norm);
}

double CMatrixOperations::VectorSupNorm(double *v, int size)
{
	double norm = 0.0;
	for(int i = 0; i < size; i++)
	{
		norm = __max(norm,fabs(v[i]));
	}
	return norm;
}

void CMatrixOperations::ElementCopy(double *vsource, double *vtarget, int size)
{
	for(int i = 0; i < size; i++)
	{
		vtarget[i] = vsource[i];
	}
	return;
}

void CMatrixOperations::RescaleVector(double *v, double scale, int size)
{
	for(int i = 0; i < size; i++)
	{
		v[i] = scale*v[i];
	}
	return;
}

void CMatrixOperations::TwoVectorLC(double a, double *x, double b, double *y, double *z, int size)
{
	for(int i = 0; i < size; i++)
	{
		z[i] = a*x[i] + b*y[i];
	}
	return;
}
