// MichaelisMentenReaction.h: interface for the MichaelisMentenReaction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MICHAELISMENTENREACTION_H__B37A12EB_8864_45ED_A3B4_10FF305B8702__INCLUDED_)
#define AFX_MICHAELISMENTENREACTION_H__B37A12EB_8864_45ED_A3B4_10FF305B8702__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Reaction.h"

class MichaelisMentenReaction : public Reaction  
{
public:
	MichaelisMentenReaction(Chemical *Enzyme, Chemical *Substrate, Chemical *Product, RateConstant *k_2, RateConstant *K_m, std::string reactionName);
	virtual ~MichaelisMentenReaction();
	double GetRate() const;
	std::vector<JElement *> *GetChemicalJacobian();
	void SetTeXForm();
protected:
	int k_2;
	int K_m;
	int Enzyme,Substrate,Product;
};

#endif // !defined(AFX_MICHAELISMENTENREACTION_H__B37A12EB_8864_45ED_A3B4_10FF305B8702__INCLUDED_)
