// NLLSMinimizable.cpp: implementation of the NLLSMinimizable class.
//
//////////////////////////////////////////////////////////////////////

#include "NLLSMinimizable.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

NLLSMinimizable::NLLSMinimizable()
{

}

NLLSMinimizable::~NLLSMinimizable()
{
	delete [] residuals;
}

void NLLSMinimizable::Allocate(int nResiduals)
{
	SetNResiduals(nResiduals);
	residuals = new double[nResiduals];
}

double NLLSMinimizable::ObjectiveFunction(double *parameters)
{
	double objFuncVal = 0.0;
	objFuncVal = ComputeResiduals(parameters);
	return objFuncVal;
}

double NLLSMinimizable::ComputeES(double *parameters, double T)
{
	double objFuncVal = 0.0;
	objFuncVal = ComputeResiduals(parameters);
	return objFuncVal;
}

double NLLSMinimizable::SumOfSquares()
{
	double sum = 0.0;
	for(int i = 0; i < nResiduals; i++)
	{
		sum += residuals[i]*residuals[i];
	}
	return sum;
}


