// NLLSMinimizable.h: interface for the NLLSMinimizable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NLLSMINIMIZABLE_H__C30960E1_4CA6_46E8_8BBA_3C586DCFD42D__INCLUDED_)
#define AFX_NLLSMINIMIZABLE_H__C30960E1_4CA6_46E8_8BBA_3C586DCFD42D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <cfloat>
#include <cmath>
#include "..\SRC\Minimizable.h"

class NLLSMinimizable : public Minimizable  
{
public:
	NLLSMinimizable();
	virtual ~NLLSMinimizable();
	void Allocate(int nResiduals);
	double SumOfSquares();
	virtual double ObjectiveFunction(double *parameters);
	virtual double ComputeResiduals(double *parameters) = 0;
	virtual double ComputeES(double *parameters, double T);
	virtual double EntropyShift(double T) = 0;
	virtual double F(double *parameters, double T) = 0;
	virtual double F0(double *parameters, double T) = 0;
	double *GetResiduals() {return residuals;}
	int GetNResiduals() {return nResiduals;}
	void SetNResiduals(int nResiduals) {this->nResiduals = nResiduals;}
protected:
	double *residuals;
	int nResiduals;
};

#endif // !defined(AFX_NLLSMINIMIZABLE_H__C30960E1_4CA6_46E8_8BBA_3C586DCFD42D__INCLUDED_)
