// OneGeneInhibitoryNetworkMinimizableDirector.h: interface for the OneGeneInhibitoryNetworkMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ONEGENEINHIBITORYNETWORKMINIMIZABLEDIRECTOR_H__B74BCAB8_23E7_4DFD_A6AA_8BDC0AD66559__INCLUDED_)
#define AFX_ONEGENEINHIBITORYNETWORKMINIMIZABLEDIRECTOR_H__B74BCAB8_23E7_4DFD_A6AA_8BDC0AD66559__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NetworkMinimizableDirector.h"
#include "OneGeneInhibitoryNetwork.h"
#include "QualityControlRungeKuttaMover.h"
#include "QualityControlCashKarpMover.h"
#include "QualityControlRK2TMover.h"
#include "GnuPlotterTimeSeriesObserver.h"
#include "RK2ExplicitEulerHybridMover.h"
#include "../src_temp/SynchronizedCashKarpMover.h"
#include "RK2TMover.h"
#include "RK4Mover.h"
#include "Experiment.h"
#include "typedefs.h"

//////////////////////////////////////////////////////////////////////
// While the one-gene inhibitory network is not realistic, it is a useful
// testbed for new functionality (integrators, optimizers, analysis 
// routines) largely because of its small size and understandable behavior.
// The director reads in fake data (produced by the simulation itself).
//////////////////////////////////////////////////////////////////////

class COneGeneInhibitoryNetworkMinimizableDirector : public NetworkMinimizableDirector  
{
public:
	COneGeneInhibitoryNetworkMinimizableDirector();
	virtual ~COneGeneInhibitoryNetworkMinimizableDirector();
	double GetParameter(int parIndex);
	int GetNParameters();
private:
	// From pure virtual function in NetworkMinimizableDirector
	void DefineExperiments();
protected:
	vpGnuPlotter m_vpPlotterList;
};

#endif // !defined(AFX_ONEGENEINHIBITORYNETWORKMINIMIZABLEDIRECTOR_H__B74BCAB8_23E7_4DFD_A6AA_8BDC0AD66559__INCLUDED_)
