// ParameterReader.cpp: implementation of the ParameterReader class.
//
//////////////////////////////////////////////////////////////////////

#include "ParameterReader.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ParameterReader::ParameterReader(std::string fileName, char commentChar)
{
	_commentChar = commentChar;
	_parameterFileStream.open(fileName.c_str());
	assert(_parameterFileStream);
}

ParameterReader::~ParameterReader()
{
	_parameterFileStream.close();
}

//////////////////////////////////////////////////////////////////////
// Reads and returns the next parameter in the file
//////////////////////////////////////////////////////////////////////

double ParameterReader::ReadParameter()
{
	double parameter = 0.0;
	// throws out comment lines
	while(_parameterFileStream.getline(_lineBuffer,sizeof(_lineBuffer)))
	{
		if(_lineBuffer[0] != _commentChar) break;
	}

	istrstream dataStream(_lineBuffer);
	dataStream >> parameter;
	
	return parameter;
}

//////////////////////////////////////////////////////////////////////
// Checks to see if we've hit EOF
//////////////////////////////////////////////////////////////////////

bool ParameterReader::IsFileGood()
{
	if(_parameterFileStream.good())
	{
		return true;
	}
	else
	{
		return false;
	}
}

void ParameterReader::Reset()
{

}
