// QualityControlCashKarpMover.h: interface for the QualityControlCashKarpMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUALITYCONTROLCASHKARPMOVER_H__7A659FAB_B4E9_4A82_8E20_65464EB830BC__INCLUDED_)
#define AFX_QUALITYCONTROLCASHKARPMOVER_H__7A659FAB_B4E9_4A82_8E20_65464EB830BC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\DifferentialEquationMover.h"
#include <cmath>
#include <stdlib.h>
#include <iomanip.h>

class CQualityControlCashKarpMover : public CDifferentialEquationMover  
{
public:
	CQualityControlCashKarpMover(double frequency, double stepSize, double eps=1.0e-5);
	virtual ~CQualityControlCashKarpMover();
	void Stepper(int nRHS, double *y, double *dydt);
	void CashKarpStep(int nRHS, double *y, double *dydt);
	virtual void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork);
protected:
	double *m_pdError;
	double *m_pdScale;
	double m_dEps;
	double m_dLastStep,m_dNextStep,m_dInitialStepSize;
	static const double m_scdA[6];
	static const double m_scdB[6][5];
	static const double m_scdC[6];
	static const double m_scdCStar[6];
	static const double m_scdSAFETY;
	static const double m_scdPGROW;
	static const double m_scdPSHRINK;
	static const double m_scdERRCON;
	static const double m_scdTINY;

};

#endif // !defined(AFX_QUALITYCONTROLCASHKARPMOVER_H__7A659FAB_B4E9_4A82_8E20_65464EB830BC__INCLUDED_)
