// QualityControlRungeKuttaMover.h: interface for the QualityControlRungeKuttaMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUALITYCONTROLRUNGEKUTTAMOVER_H__5466FBF7_4694_4098_8D01_F8D84335A75B__INCLUDED_)
#define AFX_QUALITYCONTROLRUNGEKUTTAMOVER_H__5466FBF7_4694_4098_8D01_F8D84335A75B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <cmath>
#include <stdio.h>
#include <fstream.h>
#include <iostream>
#include "RK4Mover.h"


class CQualityControlRungeKuttaMover : public CRK4Mover 
{
public:
	CQualityControlRungeKuttaMover(double frequency, double stepSize, double eps=1.0e-05);
	virtual ~CQualityControlRungeKuttaMover();
	void Stepper(int nRHS, double *y, double *dydt);
	void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork);
	void ResetStepSize();
	double GetStepSize() const;
	void SetStepSize(double newSize);
protected:
	double m_dEps;
	double m_dLastStep,m_dNextStep,m_dInitialStepSize;
	double *m_pdScale;
	static const double m_scdPGROW;
	static const double m_scdPSHRINK;
	static const double m_scdFCOR;
	static const double m_scdSAFETY;
	static const double m_scdERRCON;
	static const double m_scdTINY;
};

#endif // !defined(AFX_QUALITYCONTROLRUNGEKUTTAMOVER_H__5466FBF7_4694_4098_8D01_F8D84335A75B__INCLUDED_)


