// RK2ExplicitEulerHybridMover.h: interface for the CRK2ExplicitEulerHybridMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RK2EXPLICITEULERHYBRIDMOVER_H__1134C328_A1E8_432E_9DE0_DEB98F680963__INCLUDED_)
#define AFX_RK2EXPLICITEULERHYBRIDMOVER_H__1134C328_A1E8_432E_9DE0_DEB98F680963__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <cmath>
#include <iostream>
#include <stdlib.h>
#include "DifferentialEquationMover.h"

class CRK2ExplicitEulerHybridMover : public CDifferentialEquationMover
{
public:
	CRK2ExplicitEulerHybridMover(double tolerance=1.0e-4, double stepSize=1.0e-4);
	virtual ~CRK2ExplicitEulerHybridMover();
	void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork);
	void HybridStep(int nRHS, double *y, double *dydt);
	double SetStepScale(int nRHS);
private:
	double *m_pdLocalError;				// local error for each variable
	double m_dEps;						// numerical tolerance
	static const double m_scdAlpha;		// combination parameter
};

#endif // !defined(AFX_RK2EXPLICITEULERHYBRIDMOVER_H__1134C328_A1E8_432E_9DE0_DEB98F680963__INCLUDED_)
