// RateConstant.cpp: implementation of the RateConstant class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _WINDOWS
#include "stdafx.h"
#endif

#include "RateConstant.h"
#include <vector>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

RateConstant::RateConstant(double initialValue, std::string name)
{
	this->name = name;
	this->initialValue = initialValue;
	value = initialValue;
	errorInInitialValue = initialValue;
	this->SetTeXName();
}


RateConstant::RateConstant(double initialValue, double errorInInitialValue, std::string name)
{
	this->name = name;
	this->initialValue = initialValue;
	this->errorInInitialValue = errorInInitialValue;
	value = initialValue;
	this->SetTeXName();
}

RateConstant::~RateConstant()
{

}

double RateConstant::GetValue() const
{
	return value;
}

double RateConstant::GetInitialValue() const
{
	return initialValue;
}

double RateConstant::GetErrorInInitialValue() const
{
	return errorInInitialValue;
}

std::string RateConstant::GetName() const
{
	return name;
}

std::string RateConstant::GetTeXName() const
{
	return m_sTeXName;
}

void RateConstant::SetErrorInInitialValue(double errorInInitialValue)
{
	this->errorInInitialValue = errorInInitialValue;
}

void RateConstant::SetRateConstant(double value)
{
	this->value = value;
}

void RateConstant::Reset()
{
	SetRateConstant(initialValue);
}

void RateConstant::SetTeXName()
{
	// parse the name string into a TeX string
	strstream stream;
	// get the first character of the rate constant and then a subscript opening
	stream << name[0] << "_{\\mathrm{";
	// now the rest of the characters.  this assumes there are no other
	// underscores or TeX control characters in the string
	for(int i = 1; i < name.size(); i++)
	{
		stream << name[i];
	}
	// now close the subscript bracket
	stream << "}}" << name[name.length()];
	// set the TeX string equal to what's in the stream
	m_sTeXName = stream.str();
	// free the stream to avoid a memory leak
	stream.rdbuf()->freeze(0);
}