// RateConstant.h: interface for the RateConstant class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RATECONSTANT_H__17E9EE62_DB43_11D3_8099_00A0C9B3BB18__INCLUDED_)
#define AFX_RATECONSTANT_H__17E9EE62_DB43_11D3_8099_00A0C9B3BB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <string>
#include <sstream>
#include <strstrea.h>

class RateConstant
{
public:
	std::string GetName() const;
	std::string GetTeXName() const;
	double GetValue() const;
	double GetInitialValue() const;
	double GetErrorInInitialValue() const;
	RateConstant(double initialValue,std::string name);
	RateConstant(double initialValue=0,double errorInInitialValue=1,std::string name="");
	virtual ~RateConstant();
	void SetRateConstant(double value);
	void Reset();
	void SetErrorInInitialValue(double errorInInitialValue);
	void SetTeXName();
private:
	int rateConstantNumber;
	double value;
	double initialValue;
	double errorInInitialValue;
	std::string name;
	std::string m_sTeXName;
};

#endif // !defined(AFX_RATECONSTANT_H__17E9EE62_DB43_11D3_8099_00A0C9B3BB18__INCLUDED_)
