// Reaction.cpp: implementation of the Reaction class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _WINDOWS
#include "stdafx.h"
#endif

#include "Reaction.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Reaction::Reaction()
{

}

Reaction::Reaction(std::string reactionName)
{
	this->reactionName = reactionName;
}

Reaction::~Reaction()
{
	// WARNING:
	// chemicals and rate constants have already been deleted in the network
	// so don't delete them here!

	// clean up jacobian
	for(int i = 0; i < chemicalJacobian.size(); i++)
	{
		delete chemicalJacobian[i];
	}
}

std::vector<Chemical *> *Reaction::GetChemicals()
{
	return &chemicals;
}

void Reaction::DoReactionOnce()
{
	// Iterate over chemicals: change amount of each 
	int numChemicals = chemicals.size();
	for (int i=0; i<numChemicals; i++)
	{
		chemicals[i]->IncrementAmount(numberOfEachChemicalChangedByReaction[i]);
	}

}

int Reaction::GetNumberChangedByReaction(int chemicalNumber)
{
	return numberOfEachChemicalChangedByReaction[chemicalNumber];
}
