// RungeKuttaMover.h: interface for the CRungeKuttaMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RUNGEKUTTAMOVER_H__6A06C837_9D31_42BE_9198_7EA02ACF6632__INCLUDED_)
#define AFX_RUNGEKUTTAMOVER_H__6A06C837_9D31_42BE_9198_7EA02ACF6632__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DifferentialEquationMover.h"

class CRungeKuttaMover : public CDifferentialEquationMover  
{
public:
	CRungeKuttaMover();
	CRungeKuttaMover(double frequency,double stepSize);
	virtual ~CRungeKuttaMover();
	void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork);
	// overload RungeKuttaStep in derived classes to get methods of different order
	virtual void RungeKuttaStep(int nRHS, double *y, double *dydt) = 0;
};

#endif // !defined(AFX_RUNGEKUTTAMOVER_H__6A06C837_9D31_42BE_9198_7EA02ACF6632__INCLUDED_)
