// SumChemical.cpp: implementation of the CSumChemical class.
//
//////////////////////////////////////////////////////////////////////

#include "SumChemical.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSumChemical::CSumChemical(int chemicalNumber, std::string name, std::vector<Chemical *> chemRefVector)
:CAlgebraicChemical(chemicalNumber,name,chemRefVector)
{

}

CSumChemical::~CSumChemical()
{

}

void CSumChemical::ComputeAmount()
{
	double temp = 0.0;
	for(int i = 0; i < m_vpChemRefVector.size(); i++)
	{
		temp += m_vpChemRefVector[i]->GetAmount();
	}
	amount = temp;
}

void CSumChemical::ComputeInitialAmount()
{
	double temp = 0.0;
	for(int i = 0; i < m_vpChemRefVector.size(); i++)
	{
		temp += m_vpChemRefVector[i]->GetInitialAmount();
	}
	initialAmount = temp;
}

void CSumChemical::ComputeErrorInInitialAmount()
{
	double temp = 0.0;
	double error;
	for(int i = 0; i < m_vpChemRefVector.size(); i++)
	{
		error = m_vpChemRefVector[i]->GetErrorInInitialAmount();
		temp += error*error;
	}
	errorInInitialAmount = sqrt(temp);
}
