// TranscriptionReaction.h: interface for the TranscriptionReaction class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRANSCRIPTIONREACTION_H__FF374BEC_DD7B_11D3_8099_00A0C9B3BB18__INCLUDED_)
#define AFX_TRANSCRIPTIONREACTION_H__FF374BEC_DD7B_11D3_8099_00A0C9B3BB18__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Reaction.h"

class TranscriptionReaction : public Reaction   
{
public:
	double GetRate() const;
	TranscriptionReaction(Chemical *freePromoter, Chemical *mRNA, RateConstant *ktm, std::string reactionName);
	virtual ~TranscriptionReaction();
	std::vector<JElement *> *GetChemicalJacobian();
	void SetTeXForm();
private:
	int freePromoter, mRNA;	// Local integer variables denoting place of various chemicals on the local chemical list
	int ktm;		// Local integer variables denoting place of various rate constants on the local rate constant list

};

#endif // !defined(AFX_TRANSCRIPTIONREACTION_H__FF374BEC_DD7B_11D3_8099_00A0C9B3BB18__INCLUDED_)



