// AcceptanceRatioFreeEnergyEstimator.h: interface for the CAcceptanceRatioFreeEnergyEstimator class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ACCEPTANCERATIOFREEENERGYESTIMATOR_H__871FA004_AD66_4CDE_89BB_7D894AF3BBB2__INCLUDED_)
#define AFX_ACCEPTANCERATIOFREEENERGYESTIMATOR_H__871FA004_AD66_4CDE_89BB_7D894AF3BBB2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <fstream.h>
#include <vector>
#include <iomanip.h>
#include "../src/Minimizable.h"
#include "../src_ac/ParameterTranslator.h"
#include "../src/ParameterReader.h"

class CAcceptanceRatioFreeEnergyEstimator  
{
public:
	CAcceptanceRatioFreeEnergyEstimator();
	CAcceptanceRatioFreeEnergyEstimator(Minimizable *pS0, int n0, Minimizable *pS1, int n1, CParameterTranslator *pTrans);
	virtual ~CAcceptanceRatioFreeEnergyEstimator();
	void ComputeHistograms();
	void LoadEnsemble(std::string f0name, std::string f1name);
private:
	int m_iN0;
	int m_iN1;
	std::vector<double *> m_vpdEnsemble0;
	std::vector<double *> m_vpdEnsemble1;
	Minimizable *m_pSystem0;
	Minimizable *m_pSystem1;
	CParameterTranslator *m_pTranslator;
	std::vector<double> m_vdHistogram0;
	std::vector<double> m_vdHistogram1;
};

#endif // !defined(AFX_ACCEPTANCERATIOFREEENERGYESTIMATOR_H__871FA004_AD66_4CDE_89BB_7D894AF3BBB2__INCLUDED_)
