// CoupledOneGeneNetworksMinimizableDirector.cpp: implementation of the CCoupledOneGeneNetworksMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#include "CoupledOneGeneNetworksMinimizableDirector.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCoupledOneGeneNetworksMinimizableDirector::CCoupledOneGeneNetworksMinimizableDirector(double epsSq, double deltaSq)
:CCoupledReplicasMinimizableDirector(epsSq,deltaSq)
{
	// replica one
	m_pReplicaOne = new CAlternateOneGeneInhibitoryNetworkMinimizableDirector();
	// replica two
	m_pReplicaTwo = new COneGeneInhibitoryNetworkMinimizableDirector();

	// currently no Gamma available in this director
	m_dGammaSquared = 0.0;

	// find the parameter intersection lists
	SetIntersectionLists();

	// allocate the master residuals list
	int masterResidualsSize = 0;
	masterResidualsSize = m_pReplicaOne->GetNResiduals() + m_pReplicaTwo->GetNResiduals();
	// really only need this line if eps^2 > 0
	masterResidualsSize += m_viIntersectOne.size();
	// this line needed if delta^2 > 0
	masterResidualsSize += 1;
	if(m_dGammaSquared > 0.0)
	{
		masterResidualsSize += 1;
	}
	Allocate(masterResidualsSize);

	cout << "Master Residuals size : " << masterResidualsSize << endl;
}

CCoupledOneGeneNetworksMinimizableDirector::~CCoupledOneGeneNetworksMinimizableDirector()
{

}
