// CoupledPC12NetworksMinimizableDirector.cpp: implementation of the CCoupledPC12NetworksMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#include "CoupledPC12NetworksMinimizableDirector.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCoupledPC12NetworksMinimizableDirector::CCoupledPC12NetworksMinimizableDirector(double epsSq, double deltaSq)
:CCoupledReplicasMinimizableDirector(epsSq,deltaSq)
{
	// replica one
	m_pReplicaOne = new PC12EGFNGFMinimizableDirector();
	// replica two
	m_pReplicaTwo = new CPC12AlternateMinimizableDirector();

	// find the parameter intersection lists
	SetIntersectionLists();

	// allocate the master residuals list
	int masterResidualsSize = 0;
	masterResidualsSize = m_pReplicaOne->GetNResiduals() + m_pReplicaTwo->GetNResiduals();
	// for epsilon^2
	masterResidualsSize += m_viIntersectOne.size();
	// for delta^2
	masterResidualsSize += 1;
	if(m_dGammaSquared > 0.0)
	{
		masterResidualsSize += 1;
	}
	Allocate(masterResidualsSize);

	cout << "Master Residuals size : " << masterResidualsSize << endl;
}

CCoupledPC12NetworksMinimizableDirector::~CCoupledPC12NetworksMinimizableDirector()
{

}
