// CoupledReplicasMinimizableDirector.h: interface for the CCoupledReplicasMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COUPLEDREPLICASMINIMIZABLEDIRECTOR_H__5FBEC6D7_E482_4046_94FE_96B7D8FA44EF__INCLUDED_)
#define AFX_COUPLEDREPLICASMINIMIZABLEDIRECTOR_H__5FBEC6D7_E482_4046_94FE_96B7D8FA44EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\NetworkMinimizableDirector.h"

class CCoupledReplicasMinimizableDirector : public NetworkMinimizableDirector  
{
public:
	CCoupledReplicasMinimizableDirector(double epsSq, double deltaSq);
	virtual ~CCoupledReplicasMinimizableDirector();
	// returns the sum of GetNParameters() for both the replicas
	int GetNParameters();
	// returns the appropriate residuals
	double ComputeResiduals(double *parameters);
	// returns the appropriate parameter
	double GetParameter(int parIndex);
	// sets up the appropriate intesection lists for the two replicas
	void SetIntersectionLists();
private:
	virtual void DefineExperiments() {return;}
protected:
	NetworkMinimizableDirector *m_pReplicaOne;
	NetworkMinimizableDirector *m_pReplicaTwo;
	intVector m_viIntersectOne;
	intVector m_viIntersectTwo;
	double m_dEpsSquared;
	double m_dDeltaSquared;
};

#endif // !defined(AFX_COUPLEDREPLICASMINIMIZABLEDIRECTOR_H__5FBEC6D7_E482_4046_94FE_96B7D8FA44EF__INCLUDED_)
