// EGFRTraffickingCoupledMinimizableDirector.cpp: implementation of the CEGFRTraffickingCoupledMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#include "EGFRTraffickingCoupledMinimizableDirector.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEGFRTraffickingCoupledMinimizableDirector::CEGFRTraffickingCoupledMinimizableDirector(double epsSq, double deltaSq)
:CCoupledReplicasMinimizableDirector(epsSq,deltaSq)
{
	// replica one
	m_pReplicaOne = new CEGFRTraffickingNIH3T3MinimizableDirector();
	// replica two
	m_pReplicaTwo = new CEGFRTraffickingCHOMinimizableDirector();

	// find the parameter intersection lists
	SetIntersectionLists();

	// allocate the master residuals list
	int masterResidualsSize = 0;
	masterResidualsSize = m_pReplicaOne->GetNResiduals() + m_pReplicaTwo->GetNResiduals();
	// for epsilon^2
	masterResidualsSize += m_viIntersectOne.size();
	// for delta^2
	masterResidualsSize += 1;
	if(m_dGammaSquared > 0.0)
	{
		masterResidualsSize += 1;
	}
	Allocate(masterResidualsSize);

	cout << "Master Residuals size : " << masterResidualsSize << endl;
}

CEGFRTraffickingCoupledMinimizableDirector::~CEGFRTraffickingCoupledMinimizableDirector()
{

}
