// ErkSubnetwork.cpp: implementation of the ErkSubnetwork class.
//
//////////////////////////////////////////////////////////////////////

#ifdef _WINDOWS
#include "stdafx.h"
#endif

#include "ErkSubnetwork.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ErkSubnetwork::ErkSubnetwork()
{

	double CFactor = 600000.0, SecToMin = 60.0;

	// 1
	Chemical *EGF = new Chemical(chemicals.size(), 1000.0, "EGF");
	chemicals.push_back(EGF);

	// 2
	Chemical *NGF = new Chemical(chemicals.size(), 0.0, "NGF");
	chemicals.push_back(NGF);

	// 3
	Chemical *freeEGFReceptor = new Chemical(chemicals.size(), CFactor*0.00001667, "freeEGFReceptor");
	chemicals.push_back(freeEGFReceptor);

	// 4
	Chemical *boundEGFReceptor = new Chemical(chemicals.size(), 0.0, "boundEGFReceptor");
	chemicals.push_back(boundEGFReceptor);

	// 5
	Chemical *freeNGFReceptor = new Chemical(chemicals.size(), CFactor*0.00001667, "freeNGFReceptor");
	chemicals.push_back(freeNGFReceptor);

	// 6
	Chemical *boundNGFReceptor = new Chemical(chemicals.size(), 0.0, "boundNGFReceptor");
	chemicals.push_back(boundNGFReceptor);

	// 7
	Chemical *SosInactive = new Chemical(chemicals.size(), 0.1*CFactor, "SosInactive");
	chemicals.push_back(SosInactive);
		
	// 8
	Chemical *SosActive = new Chemical(chemicals.size(), 0.0, "SosActive");
	chemicals.push_back(SosActive);

	// 9
	Chemical *P90RskInactive = new Chemical(chemicals.size(), 10000.0, "P90RskInactive");
	chemicals.push_back(P90RskInactive);

	// 10
	Chemical *P90RskActive = new Chemical(chemicals.size(), 0.0, "P90RskActive");
	chemicals.push_back(P90RskActive);

	// 11
	Chemical *RasInactive = new Chemical(chemicals.size(), 0.2*CFactor, "RasInactive");
	chemicals.push_back(RasInactive);
		
	// 12
	Chemical *RasActive = new Chemical(chemicals.size(), 0.0, "RasActive");
	chemicals.push_back(RasActive);

	// 13
	Chemical *RasGapInactive = new Chemical(chemicals.size(), CFactor*0.002, "RasGapInactive");
	chemicals.push_back(RasGapInactive);

	// 14
	Chemical *RasGapActive = new Chemical(chemicals.size(), CFactor*0.002, "RasGapActive");
	chemicals.push_back(RasGapActive);

	// 15
	Chemical *Raf1Inactive = new Chemical(chemicals.size(), CFactor*0.2, "Raf1Inactive");
	chemicals.push_back(Raf1Inactive);
		
	// 16
	Chemical *Raf1Active = new Chemical(chemicals.size(), 0.0, "Raf1Active");
	chemicals.push_back(Raf1Active);

	// 17
	Chemical *BRafInactive = new Chemical(chemicals.size(), CFactor*0.2, "BRafInactive");
	chemicals.push_back(BRafInactive);
		
	// 18
	Chemical *BRafActive = new Chemical(chemicals.size(), 0.0, "BRafActive");
	chemicals.push_back(BRafActive);

	// 19
	Chemical *MekInactive = new Chemical(chemicals.size(), 0.18*CFactor, "MekInactive");
	chemicals.push_back(MekInactive);

	// 20
	Chemical *MekActive = new Chemical(chemicals.size(), 0.0, "MekActive");
	chemicals.push_back(MekActive);

	// 21
	Chemical *ErkInactiveCytoplasmic = new Chemical(chemicals.size(),0.36*CFactor, "ErkInactiveCytoplasmic");
	chemicals.push_back(ErkInactiveCytoplasmic);
		
	// 22
	Chemical *ErkActiveCytoplasmic = new Chemical(chemicals.size(), 0.0, "ErkActiveCytoplasmic");
	chemicals.push_back(ErkActiveCytoplasmic);

//	Chemical *ErkPhosphataseCytoplasmic2 = new Chemical(chemicals.size(), 0.1*CFactor, "ErkPhosphataseCytoplasmic2");
//	chemicals.push_back(ErkPhosphataseCytoplasmic2);

	// 23
	Chemical *ErkInactiveNuclear = new Chemical(chemicals.size(), 0.0, "ErkInactiveNuclear");
	chemicals.push_back(ErkInactiveNuclear);
		
	// 24
	Chemical *ErkActiveNuclear = new Chemical(chemicals.size(), 0.0, "ErkActiveNuclear");
	chemicals.push_back(ErkActiveNuclear);

	// 25
	Chemical *ErkPhosphataseNuclear = new Chemical(chemicals.size(), 0.1*CFactor, "ErkPhosphataseNuclear");
	chemicals.push_back(ErkPhosphataseNuclear);

	// 26
	Chemical *PI3KInactive = new Chemical(chemicals.size(), 0.1*CFactor, "PI3KInactive");
	chemicals.push_back(PI3KInactive);

	// 27
	Chemical *PI3KActive = new Chemical(chemicals.size(), 0.0, "PI3KActive");
	chemicals.push_back(PI3KActive);

	// 28
	Chemical *AktInactive = new Chemical(chemicals.size(), 0.1*CFactor, "AktInactive");
	chemicals.push_back(AktInactive);

	// 29
	Chemical *AktActive = new Chemical(chemicals.size(), 0.0, "AktActive");
	chemicals.push_back(AktActive);

	// 30 
	Chemical *RapGEFInactive = new Chemical(chemicals.size(), 0.1*CFactor, "RapGEFInactive");
	chemicals.push_back(RapGEFInactive);
		
	// 31
	Chemical *RapGEFActive = new Chemical(chemicals.size(), 0.0, "RapGEFActive");
	chemicals.push_back(RapGEFActive);

	// 32
	Chemical *RapInactive = new Chemical(chemicals.size(), 0.1*CFactor, "RapInactive");
	chemicals.push_back(RapInactive);

	// 33
	Chemical *RapActive = new Chemical(chemicals.size(), 0.0, "RapActive");
	chemicals.push_back(RapActive);

	// 34
	Chemical *RapGapInactive = new Chemical(chemicals.size(), 0.0, "RapGapInactive");
	chemicals.push_back(RapGapInactive);
		
	// 35
	Chemical *RapGapActive = new Chemical(chemicals.size(), 0.1*CFactor, "RapGapActive");
	chemicals.push_back(RapGapActive);
	
	// 36
	Chemical *Sp1Inactive = new Chemical(chemicals.size(), 0.1*CFactor, "Sp1Inactive");
	chemicals.push_back(Sp1Inactive);

	// 37
	Chemical *Sp1Active = new Chemical(chemicals.size(), 0.0, "Sp1Active");
	chemicals.push_back(Sp1Active);

	// 38
	Chemical *CyclinDfreePromoter = new Chemical(chemicals.size(), 1.0, "CyclinDfreePromoter");
	chemicals.push_back(CyclinDfreePromoter);

	// 39
	Chemical *CyclinDboundPromoter = new Chemical(chemicals.size(), 0.0, "CyclinDboundPromoter");
	chemicals.push_back(CyclinDboundPromoter);

	// 40
	Chemical *CyclinDmRNA = new Chemical(chemicals.size(), 0.0, "CyclinDmRNA");
	chemicals.push_back(CyclinDmRNA);

	// 41
	Chemical *CyclinD = new Chemical(chemicals.size(), 0.0, "CyclinD");
	chemicals.push_back(CyclinD);

	// 42
	Chemical *P21freePromoter = new Chemical(chemicals.size(), 1.0, "P21freePromoter");
	chemicals.push_back(P21freePromoter);

	// 43
	Chemical *P21boundPromoter = new Chemical(chemicals.size(), 0.0, "P21boundPromoter");
	chemicals.push_back(P21boundPromoter);

	// 44
	Chemical *P21mRNA = new Chemical(chemicals.size(), 0.0, "P21mRNA");
	chemicals.push_back(P21mRNA);

	// 45
	Chemical *P21 = new Chemical(chemicals.size(), 0.0, "P21");
	chemicals.push_back(P21);

	// 46
	Chemical *CFosfreePromoter = new Chemical(chemicals.size(), 1.0, "CFosfreePromoter");
	chemicals.push_back(CFosfreePromoter);

	// 47
	Chemical *CFosboundPromoter = new Chemical(chemicals.size(), 0.0, "CFosboundPromoter");
	chemicals.push_back(CFosboundPromoter);

	// 48
	Chemical *CFosmRNA = new Chemical(chemicals.size(), 0.0, "CFosmRNA");
	chemicals.push_back(CFosmRNA);

	// 49
	Chemical *CFos = new Chemical(chemicals.size(), 0.0, "CFos");
	chemicals.push_back(CFos);

	// 50
	Chemical *ErkPhosphataseCytoplasmicfreePromoter = new Chemical(chemicals.size(), 1.0, "ErkPhosphataseCytoplasmicfreePromoter");
	chemicals.push_back(ErkPhosphataseCytoplasmicfreePromoter);

	// 51
	Chemical *ErkPhosphataseCytoplasmicboundPromoter = new Chemical(chemicals.size(), 0.0, "ErkPhosphataseCytoplasmicboundPromoter");
	chemicals.push_back(ErkPhosphataseCytoplasmicboundPromoter);

	// 52
	Chemical *ErkPhosphataseCytoplasmicmRNA = new Chemical(chemicals.size(), 0.0, "ErkPhosphataseCytoplasmicmRNA");
	chemicals.push_back(ErkPhosphataseCytoplasmicmRNA);

	// 53
	Chemical *ErkPhosphataseCytoplasmic = new Chemical(chemicals.size(), 0.0, "ErkPhosphataseCytoplasmic");
	chemicals.push_back(ErkPhosphataseCytoplasmic);

	// 54
	Chemical *freePromoter = new Chemical(chemicals.size(), 1.0, "freePromoter");
	chemicals.push_back(freePromoter);

	// 55
	Chemical *boundPromoter = new Chemical(chemicals.size(), 0.0, "boundPromoter");
	chemicals.push_back(boundPromoter);

	// 56
	Chemical *mRNA = new Chemical(chemicals.size(), 0.0, "mRNA");
	chemicals.push_back(mRNA);

	// 57
	Chemical *protein = new Chemical(chemicals.size(), 0.0, "protein");
	chemicals.push_back(protein);

	// 58
	Chemical *filler = new Chemical(chemicals.size(), 1.0, "filler");
	chemicals.push_back(filler);


	RateConstant *k_rb_EGF = new RateConstant(SecToMin*0.000007, "k_rb_EGF");
	RateConstant *k_ru_EGF = new RateConstant(SecToMin*0.25, "k_ru_EGF");
	RateConstant *k_rb_NGF = new RateConstant(SecToMin*0.000007, "k_rb_NGF");
	RateConstant *k_ru_NGF = new RateConstant(SecToMin*0.25, "k_ru_NGF");

	RateConstant *k_EGF = new RateConstant(SecToMin*5976, "k_EGF");
	RateConstant *Km_EGF = new RateConstant(CFactor*0.8333, "Km_EGF");
	RateConstant *k_NGF = new RateConstant(SecToMin*0.25, "k_NGF");
	RateConstant *Km_NGF = new RateConstant(CFactor*0.8333, "Km_NGF");

	RateConstant *k_dSos = new RateConstant(0.00167*SecToMin, "k_dSos");
	RateConstant *Km_dSos = new RateConstant(100000.0, "Km_dSos");
	RateConstant *k_Sos = new RateConstant(SecToMin*0.02, "k_Sos");
	RateConstant *Km_Sos = new RateConstant(0.505*CFactor, "Km_Sos");

	RateConstant *k_RasGap = new RateConstant(10.0*SecToMin, "k_RasGap");
	RateConstant *Km_RasGap = new RateConstant(CFactor*1.0104, "Km_RasGap");
	RateConstant *k_RasToRaf1 = new RateConstant(0.01, "k_RasToRaf1");
	RateConstant *Km_RasToRaf1 = new RateConstant(300000.0, "Km_RasToRaf1");

	RateConstant *k_pRaf1 = new RateConstant(0.1*SecToMin, "k_pRaf1");
	RateConstant *Km_pRaf1 = new RateConstant(300000.0, "Km_pRaf1");
	RateConstant *k_pBRaf = new RateConstant(0.01*SecToMin, "k_pBRaf");
	RateConstant *Km_pBRaf = new RateConstant(300000.0, "Km_pBRaf");
	RateConstant *k_dMek = new RateConstant(0.01*SecToMin*1000000, "k_dMek");
	RateConstant *Km_dMek = new RateConstant(300000.0, "Km_dMek");

	RateConstant *k_pMek_Cytoplasmic = new RateConstant(0.01*SecToMin, "k_pMek_Cytoplasmic");
	RateConstant *Km_pMek_Cytoplasmic = new RateConstant(300000.0, "Km_pMek_Cytoplasmic");
	RateConstant *k_dErk_Cytoplasmic = new RateConstant(0.01*SecToMin, "k_dErk_Cytoplasmic");
	RateConstant *Km_dErk_Cytoplasmic = new RateConstant(300000.0, "Km_dErk_Cytoplasmic");
//	RateConstant *k_dErk_Cytoplasmic2 = new RateConstant(0.001*SecToMin, "k_dErk_Cytoplasmic2");
//	RateConstant *Km_dErk_Cytoplasmic2 = new RateConstant(300000.0, "Km_dErk_Cytoplasmic2");
	RateConstant *k_pP90Rsk = new RateConstant(0.01*SecToMin, "k_pP90Rsk");
	RateConstant *Km_pP90Rsk = new RateConstant(300000.0, "Km_pP90Rsk");

	RateConstant *k_PI3K = new RateConstant(0.01*SecToMin, "k_PI3K");
	RateConstant *Km_PI3K = new RateConstant(300000.0, "Km_PI3K");
	RateConstant *k_PI3K_Ras = new RateConstant(0.01*SecToMin, "k_PI3K_Ras");
	RateConstant *Km_PI3K_Ras = new RateConstant(300000.0, "Km_PI3K_Ras");
	RateConstant *k_dPI3K = new RateConstant(0.01*SecToMin, "k_dPI3K");
	RateConstant *Km_dPI3K = new RateConstant(300000.0, "Km_dPI3K");
	RateConstant *k_Akt = new RateConstant(0.01, "k_Akt");
	RateConstant *Km_Akt = new RateConstant(300000.0, "Km_Akt");
	RateConstant *k_dAkt = new RateConstant(0.01*SecToMin, "k_dAkt");
	RateConstant *Km_dAkt = new RateConstant(300000.0, "Km_dAkt");
	RateConstant *k_dRaf1ByAkt = new RateConstant(0.01*SecToMin, "k_dRaf1ByAkt");
	RateConstant *Km_Raf1ByAkt = new RateConstant(300000.0, "Km_Raf1ByAkt"); 

	RateConstant *k_Rap_GEF_NGF = new RateConstant(0.01*SecToMin, "k_Rap_GEF_NGF");
	RateConstant *Km_RapGef_NGF = new RateConstant(300000.0, "Km_RapGef_NGF");
	RateConstant *k_dRapGEF = new RateConstant(0.01*SecToMin, "k_dRapGEF");
	RateConstant *Km_dRapGEF = new RateConstant(300000.0, "Km_dRapGEF");
	RateConstant *k_RapGEF = new RateConstant(0.01*SecToMin, "k_RapGEF"); 
	RateConstant *Km_RapGEF = new RateConstant(300000.0, "Km_RapGEF");
	RateConstant *k_RapGap = new RateConstant(0.01*SecToMin, "k_RapGap");
	RateConstant *Km_RapGap = new RateConstant(300000.0, "Km_RapGap");
	RateConstant *k_RapToBRaf = new RateConstant(0.01*SecToMin, "k_RapToBRaf");
	RateConstant *Km_RapToBRaf = new RateConstant(300000.0, "Km_RapToBRaf");
	RateConstant *k_dRapToRaf1 = new RateConstant(0.01*SecToMin, "k_dRapToRaf1");
	RateConstant *Km_dRapToRaf1 = new RateConstant(300000.0, "Km_dRapToRaf1");

	RateConstant *ktrans_Erk = new RateConstant(0.01*SecToMin, "ktrans_Erk");
	RateConstant *k_dErkActiveNuclear = new RateConstant(0.1*SecToMin, "k_dErkActiveNuclear");
	RateConstant *Km_dErkActiveNuclear = new RateConstant(300000.0, "Km_dErkActiveNuclear");

	RateConstant *k_pSp1 = new RateConstant(0.01*SecToMin, "k_pSp1");
	RateConstant *Km_pSp1 = new RateConstant(300000.0, "Km_pSp1");
	RateConstant *k_dSp1 = new RateConstant(0.01*SecToMin, "k_dSp1");
	RateConstant *Km_dSp1 = new RateConstant(300000.0, "Km_dSp1");

    RateConstant *kb_CyclinD = new RateConstant(0.006, "kb_CyclinD");
    RateConstant *ku_CyclinD = new RateConstant(0.0006, "ku_CyclinD");
    RateConstant *ktm_CyclinD = new RateConstant(1.0, "ktm_CyclinD");
    RateConstant *kdm_CyclinD = new RateConstant(1.0/30.0, "kdm_CyclinD");
    RateConstant *kt_CyclinD = new RateConstant(1.0/6.0, "kt_CyclinD");
    RateConstant *kd_CyclinD = new RateConstant(1.0/100.0, "kd_CyclinD");  

    RateConstant *kb_P21 = new RateConstant(0.006, "kb_P21");
    RateConstant *ku_P21 = new RateConstant(0.0006, "ku_P21");
    RateConstant *ktm_P21 = new RateConstant(1.0, "ktm_P21");
    RateConstant *kdm_P21 = new RateConstant(1.0/30.0, "kdm_P21");
    RateConstant *kt_P21 = new RateConstant(1.0/6.0, "kt_P21");
    RateConstant *kd_P21 = new RateConstant(1.0/100.0, "kd_P21");

    RateConstant *kb_CFos = new RateConstant(0.006, "kb_CFos");
    RateConstant *ku_CFos = new RateConstant(0.0006, "ku_CFos");
    RateConstant *ktm_CFos = new RateConstant(1.0, "ktm_CFos");
    RateConstant *kdm_CFos = new RateConstant(1.0/30.0, "kdm_CFos");
    RateConstant *kt_CFos = new RateConstant(1.0/6.0, "kt_CFos");
    RateConstant *kd_CFos = new RateConstant(1.0/100.0, "kd_CFos");     

    RateConstant *kb_ErkPhosphataseCytoplasmic = new RateConstant(0.006, "kb_ErkPhosphataseCytoplasmic");
    RateConstant *ku_ErkPhosphataseCytoplasmic = new RateConstant(0.0006, "ku_ErkPhosphataseCytoplasmic");
    RateConstant *ktm_ErkPhosphataseCytoplasmic = new RateConstant(1.0, "ktm_ErkPhosphataseCytoplasmic");
    RateConstant *kdm_ErkPhosphataseCytoplasmic = new RateConstant(1.0/30.0,"kdm_ErkPhosphataseCytoplasmic");
    RateConstant *kt_ErkPhosphataseCytoplasmic = new RateConstant(1.0/6.0, "kt_ErkPhosphataseCytoplasmic");
    RateConstant *kd_ErkPhosphataseCytoplasmic = new RateConstant(1.0/100.0,"kd_ErkPhosphataseCytoplasmic");

    RateConstant *kb = new RateConstant(0.006, "kb");
    RateConstant *ku = new RateConstant(0.0006, "ku");
    RateConstant *ktm = new RateConstant(1.0, "ktm");
    RateConstant *kdm = new RateConstant(1.0/30.0, "kdm");
    RateConstant *kt = new RateConstant(1.0/6.0, "kt");
    RateConstant *kd = new RateConstant(1.0/100.0, "kd");                  


	rateConstants.push_back(k_rb_EGF);
	rateConstants.push_back(k_ru_EGF);
	rateConstants.push_back(k_rb_NGF);
	rateConstants.push_back(k_ru_NGF);

	rateConstants.push_back(k_EGF);
	rateConstants.push_back(Km_EGF);
	rateConstants.push_back(k_NGF);
	rateConstants.push_back(Km_NGF);

	rateConstants.push_back(k_dSos);
	rateConstants.push_back(Km_dSos);
	rateConstants.push_back(k_Sos);
	rateConstants.push_back(Km_Sos);
	rateConstants.push_back(k_RasGap);
	rateConstants.push_back(Km_RasGap);
	rateConstants.push_back(k_RasToRaf1);
	rateConstants.push_back(Km_RasToRaf1);
	rateConstants.push_back(k_pRaf1);
	rateConstants.push_back(Km_pRaf1);
	rateConstants.push_back(k_pBRaf);
	rateConstants.push_back(Km_pBRaf);
	rateConstants.push_back(k_dMek);
	rateConstants.push_back(Km_dMek);

	rateConstants.push_back(k_pMek_Cytoplasmic);
	rateConstants.push_back(Km_pMek_Cytoplasmic);
	rateConstants.push_back(k_dErk_Cytoplasmic);
	rateConstants.push_back(Km_dErk_Cytoplasmic);
//	rateConstants.push_back(k_dErk_Cytoplasmic2);
//	rateConstants.push_back(Km_dErk_Cytoplasmic2);
	rateConstants.push_back(k_pP90Rsk);
	rateConstants.push_back(Km_pP90Rsk);

	rateConstants.push_back(k_PI3K);
	rateConstants.push_back(Km_PI3K);
	rateConstants.push_back(k_PI3K_Ras);
	rateConstants.push_back(Km_PI3K_Ras);
	rateConstants.push_back(k_dPI3K);
	rateConstants.push_back(Km_dPI3K);

	rateConstants.push_back(k_Akt);
	rateConstants.push_back(Km_Akt);
	rateConstants.push_back(k_dAkt);
	rateConstants.push_back(Km_dAkt);
	rateConstants.push_back(k_dRaf1ByAkt);
	rateConstants.push_back(Km_Raf1ByAkt);

	rateConstants.push_back(k_Rap_GEF_NGF);
	rateConstants.push_back(Km_RapGef_NGF);
	rateConstants.push_back(k_dRapGEF);
	rateConstants.push_back(Km_dRapGEF);
	rateConstants.push_back(k_RapGEF);
	rateConstants.push_back(Km_RapGEF);
	rateConstants.push_back(k_RapGap);
	rateConstants.push_back(Km_RapGap);
	rateConstants.push_back(k_RapToBRaf);
	rateConstants.push_back(Km_RapToBRaf);
	rateConstants.push_back(k_dRapToRaf1);
	rateConstants.push_back(Km_dRapToRaf1);

	rateConstants.push_back(ktrans_Erk);
	rateConstants.push_back(k_dErkActiveNuclear);
	rateConstants.push_back(Km_dErkActiveNuclear);

	rateConstants.push_back(k_pSp1);
	rateConstants.push_back(Km_pSp1);
	rateConstants.push_back(k_dSp1);
	rateConstants.push_back(Km_dSp1);

	rateConstants.push_back(kb_CyclinD);
	rateConstants.push_back(ku_CyclinD);
	rateConstants.push_back(ktm_CyclinD);
	rateConstants.push_back(kdm_CyclinD);
	rateConstants.push_back(kt_CyclinD);
	rateConstants.push_back(kd_CyclinD);

	rateConstants.push_back(kb_P21);
	rateConstants.push_back(ku_P21);
	rateConstants.push_back(ktm_P21);
	rateConstants.push_back(kdm_P21);
	rateConstants.push_back(kt_P21);
	rateConstants.push_back(kd_P21);

	rateConstants.push_back(kb_CFos);
	rateConstants.push_back(ku_CFos);
	rateConstants.push_back(ktm_CFos);
	rateConstants.push_back(kdm_CFos);
	rateConstants.push_back(kt_CFos);
	rateConstants.push_back(kd_CFos);

	rateConstants.push_back(kb_ErkPhosphataseCytoplasmic);
	rateConstants.push_back(ku_ErkPhosphataseCytoplasmic);
	rateConstants.push_back(ktm_ErkPhosphataseCytoplasmic);
	rateConstants.push_back(kdm_ErkPhosphataseCytoplasmic);
	rateConstants.push_back(kt_ErkPhosphataseCytoplasmic);
	rateConstants.push_back(kd_ErkPhosphataseCytoplasmic);

	rateConstants.push_back(kb);
	rateConstants.push_back(ku);
	rateConstants.push_back(ktm);
	rateConstants.push_back(kdm);
	rateConstants.push_back(kt);
	rateConstants.push_back(kd);


	ReceptorBindingReaction *EGFBindingReaction = new ReceptorBindingReaction(EGF, freeEGFReceptor, boundEGFReceptor, k_rb_EGF, "EGFBindingReaction");
	ReceptorUnbindingReaction *EGFUnbindingReaction = new ReceptorUnbindingReaction(boundEGFReceptor, freeEGFReceptor, EGF, k_ru_EGF, "EGFUnbindingReaction");
	ReceptorBindingReaction *NGFBindingReaction = new ReceptorBindingReaction(NGF, freeNGFReceptor, boundNGFReceptor, k_rb_NGF, "NGFBindingReaction");
	ReceptorUnbindingReaction *NGFUnbindingReaction = new ReceptorUnbindingReaction(boundNGFReceptor, freeNGFReceptor, NGF, k_ru_NGF, "NGFUnbindingReaction");

	MichaelisMentenPhosphorylationReaction *SosActivationByEGFReaction = new MichaelisMentenPhosphorylationReaction(boundEGFReceptor, SosInactive, SosActive, k_EGF, Km_EGF, "SosActivationbyEGFReaction");
	MichaelisMentenPhosphorylationReaction *SosActivationByNGFReaction = new MichaelisMentenPhosphorylationReaction(boundNGFReceptor, SosInactive, SosActive, k_NGF, Km_NGF, "SosActivationbyNGFReaction");
	MichaelisMentenDephosphorylationReaction *SosDeactivationReaction = new MichaelisMentenDephosphorylationReaction(P90RskActive, SosActive, SosInactive, k_dSos, Km_dSos, "SosDeactivationReaction");
	MichaelisMentenGProteinActivationReaction *RasActivationReaction = new MichaelisMentenGProteinActivationReaction(SosActive, RasInactive, RasActive, k_Sos, Km_Sos, "RasActivationReaction");
	MichaelisMentenGProteinDeactivationReaction *RasDeactivationReaction = new MichaelisMentenGProteinDeactivationReaction(RasGapActive, RasActive, RasInactive, k_RasGap, Km_RasGap, "RasDeactivationReaction");
	MichaelisMentenProteinProteinActivationReaction *Raf1ByRasActivationReaction = new MichaelisMentenProteinProteinActivationReaction(RasActive, Raf1Inactive, Raf1Active, k_RasToRaf1, Km_RasToRaf1, "Raf1ByRasActivationReaction");

	MichaelisMentenPhosphorylationReaction *MekbyRaf1ActivationReaction = new MichaelisMentenPhosphorylationReaction(Raf1Active, MekInactive, MekActive, k_pRaf1, Km_pRaf1, "MekbyRaf1ActivationReaction");
	MichaelisMentenPhosphorylationReaction *MekbyBRafActivationReaction = new MichaelisMentenPhosphorylationReaction(BRafActive, MekInactive, MekActive, k_pBRaf, Km_pBRaf, "MekbyBRafActivationReaction");
	MichaelisMentenDephosphorylationReaction *MekDeactivationReaction = new MichaelisMentenDephosphorylationReaction(filler, MekActive, MekInactive, k_dMek, Km_dMek, "MekDeactivationReaction");
	MichaelisMentenPhosphorylationReaction *ErkActivationCytoplasmicReaction = new MichaelisMentenPhosphorylationReaction(MekActive, ErkInactiveCytoplasmic, ErkActiveCytoplasmic, k_pMek_Cytoplasmic, Km_pMek_Cytoplasmic, "ErkActivationCytoplasmicReaction");
	MichaelisMentenDephosphorylationReaction *ErkDeactivationCytoplasmicReaction = new MichaelisMentenDephosphorylationReaction(ErkPhosphataseCytoplasmic, ErkActiveCytoplasmic, ErkInactiveCytoplasmic, k_dErk_Cytoplasmic, Km_dErk_Cytoplasmic, "ErkDeactivationCytoplasmicReaction");
//	MichaelisMentenDephosphorylationReaction *ErkDeactivationCytoplasmicReaction2 = new MichaelisMentenDephosphorylationReaction(ErkPhosphataseCytoplasmic2, ErkActiveCytoplasmic, ErkInactiveCytoplasmic, k_dErk_Cytoplasmic2, Km_dErk_Cytoplasmic2, "ErkDeactivationCytoplasmicReaction2");
	MichaelisMentenPhosphorylationReaction *P90RskActivationReaction = new MichaelisMentenPhosphorylationReaction(ErkActiveCytoplasmic, P90RskInactive, P90RskActive, k_pP90Rsk, Km_pP90Rsk, "P90RskActivationReaction");

	MichaelisMentenPhosphorylationReaction *PI3KEGFActivationReaction = new MichaelisMentenPhosphorylationReaction(boundEGFReceptor, PI3KInactive, PI3KActive, k_PI3K, Km_PI3K, "PI3KEGFActivationReaction");
	MichaelisMentenProteinProteinActivationReaction *PI3KRasActivationReaction = new MichaelisMentenProteinProteinActivationReaction(RasActive, PI3KInactive, PI3KActive, k_PI3K_Ras, Km_PI3K_Ras, "PI3KRasActivationReaction");
	MichaelisMentenDephosphorylationReaction *PI3KDeactivationReaction = new MichaelisMentenDephosphorylationReaction(filler, PI3KActive, PI3KInactive, k_dPI3K, Km_dPI3K, "PI3KDeactivationReaction");
	MichaelisMentenPhosphorylationReaction *AktActivationReaction = new MichaelisMentenPhosphorylationReaction(PI3KActive, AktInactive, AktActive, k_Akt, Km_Akt, "AktActivationReaction");
	MichaelisMentenDephosphorylationReaction *AktDeactivationReaction = new MichaelisMentenDephosphorylationReaction(filler, AktActive, AktInactive, k_dAkt, Km_dAkt, "AktDeactivationReaction");	
	MichaelisMentenProteinProteinDeactivationReaction *Raf1ByAktDeactivationReaction = new MichaelisMentenProteinProteinDeactivationReaction(AktActive, Raf1Active, Raf1Inactive, k_dRaf1ByAkt, Km_Akt, "RafByAktDeactivationReaction");

	MichaelisMentenPhosphorylationReaction *RapGEFActivationReaction = new MichaelisMentenPhosphorylationReaction(boundNGFReceptor, SosInactive, SosActive, k_Rap_GEF_NGF, Km_RapGef_NGF, "RapGEFActivationReaction");
	MichaelisMentenDephosphorylationReaction *RapGEFDeactivationReaction = new MichaelisMentenDephosphorylationReaction(filler, RapGEFActive, RapGEFInactive, k_dRapGEF, Km_dRapGEF, "RapGEFDeactivationReaction");
	MichaelisMentenGProteinActivationReaction *RapActivationReaction = new MichaelisMentenGProteinActivationReaction(RapGEFActive, RapInactive, RapActive, k_RapGEF, Km_RapGEF, "RapActivationReaction");
	MichaelisMentenGProteinDeactivationReaction *RapDeactivationReaction = new MichaelisMentenGProteinDeactivationReaction(RapGapActive, RapActive, RapInactive, k_RapGap, Km_RapGap, "RapDeactivationReaction");
	MichaelisMentenProteinProteinActivationReaction *BRafByRapActivationReaction = new MichaelisMentenProteinProteinActivationReaction(RapActive, BRafInactive, BRafActive, k_RapToBRaf, Km_RapToBRaf, "BRafByRapActivationReaction");
	MichaelisMentenProteinProteinDeactivationReaction *Raf1ByRapDeactivationReaction = new MichaelisMentenProteinProteinDeactivationReaction(RapActive, Raf1Active, Raf1Inactive, k_dRapToRaf1, Km_dRapToRaf1, "Raf1ByRapDeactivationReaction");

	ChemicalTransportReaction *ErkActiveNuclearTranslocationReaction = new ChemicalTransportReaction(ErkActiveCytoplasmic, ErkActiveNuclear, ktrans_Erk, "ErkActiveNuclearTranslocation");
	ChemicalTransportReaction *ErkActiveCytoplasmicTranslocationReaction = new ChemicalTransportReaction(ErkActiveNuclear, ErkActiveCytoplasmic, ktrans_Erk, "ErkActiveCytoplasmicTranslocation");	
	MichaelisMentenDephosphorylationReaction *ErkActiveNuclearDephosphorylationReaction = new MichaelisMentenDephosphorylationReaction(ErkPhosphataseNuclear, ErkActiveNuclear, ErkInactiveNuclear, k_dErkActiveNuclear, Km_dErkActiveNuclear, "ErkActiveNuclearDephosphorylationReaction");

	MichaelisMentenPhosphorylationReaction *Sp1ActivationReaction = new MichaelisMentenPhosphorylationReaction(ErkActiveNuclear, Sp1Inactive, Sp1Active, k_pSp1, Km_pSp1, "Sp1ActivationReaction");
	MichaelisMentenDephosphorylationReaction *Sp1DeactivationReaction = new MichaelisMentenDephosphorylationReaction(filler, Sp1Active, Sp1Inactive, k_dSp1, Km_dSp1, "Sp1DeactivationReaction");

	PromoterBindingReaction *CyclinDbindingReaction = new PromoterBindingReaction(CyclinDfreePromoter, Sp1Active, CyclinDboundPromoter, kb, "CyclinDbindingReaction");
	PromoterUnbindingReaction *CyclinDunbindingReaction = new PromoterUnbindingReaction(CyclinDboundPromoter, CyclinDfreePromoter, Sp1Active, ku_CyclinD, "CyclinDunbindingReaction");
	TranscriptionReaction *CyclinDtranscriptionReaction = new TranscriptionReaction(CyclinDboundPromoter, CyclinDmRNA, ktm_CyclinD, "CyclinDtranscriptionReaction");
	RNADegradationReaction *CyclinDmRNADegradationReaction = new RNADegradationReaction(CyclinDmRNA, kdm_CyclinD, "CyclinDmRNADegradationReaction");
	ProteinTranslationReaction *CyclinDtranslationReaction = new ProteinTranslationReaction(CyclinDmRNA, CyclinD, kt_CyclinD, "CyclinDtranslationReaction");
	UnstableProteinDegradationReaction *CyclinDproteinDegradationReaction = new UnstableProteinDegradationReaction(CyclinD, kd_CyclinD, "CyclinDproteinDegradationReaction");

	PromoterBindingReaction *P21bindingReaction = new PromoterBindingReaction(P21freePromoter, Sp1Active, P21boundPromoter, kb_P21, "P21bindingReaction");
	PromoterUnbindingReaction *P21unbindingReaction = new PromoterUnbindingReaction(P21boundPromoter, P21freePromoter, Sp1Active, ku_P21, "P21unbindingReaction");
	TranscriptionReaction *P21transcriptionReaction = new TranscriptionReaction(P21boundPromoter, P21mRNA, ktm_P21, "P21transcriptionReaction");
	RNADegradationReaction *P21mRNADegradationReaction = new RNADegradationReaction(P21mRNA, kdm_P21, "P21mRNADegradationReaction");
	ProteinTranslationReaction *P21translationReaction = new ProteinTranslationReaction(P21mRNA, P21, kt_P21, "P21translationReaction");
	UnstableProteinDegradationReaction *P21proteinDegradationReaction = new UnstableProteinDegradationReaction(P21, kd_P21, "P21proteinDegradationReaction");

	PromoterBindingReaction *CFosbindingReaction = new PromoterBindingReaction(CFosfreePromoter, Sp1Active, CFosboundPromoter, kb_CFos, "CFosbindingReaction");
	PromoterUnbindingReaction *CFosunbindingReaction = new PromoterUnbindingReaction(CFosboundPromoter, CFosfreePromoter, Sp1Active, ku_CFos, "CFosunbindingReaction");
	TranscriptionReaction *CFostranscriptionReaction = new TranscriptionReaction(CFosboundPromoter, CFosmRNA, ktm_CFos, "CFostranscriptionReaction");
	RNADegradationReaction *CFosmRNADegradationReaction = new RNADegradationReaction(CFosmRNA, kdm_CFos, "CFosmRNADegradationReaction");
	ProteinTranslationReaction *CFostranslationReaction = new ProteinTranslationReaction(CFosmRNA, CFos, kt_CFos, "CFostranslationReaction");
	UnstableProteinDegradationReaction *CFosproteinDegradationReaction = new UnstableProteinDegradationReaction(CFos, kd_CFos, "CFosproteinDegradationReaction");

	PromoterBindingReaction *ErkPhosphataseCytoplasmicbindingReaction = new PromoterBindingReaction(ErkPhosphataseCytoplasmicfreePromoter, Sp1Active, ErkPhosphataseCytoplasmicboundPromoter, kb_ErkPhosphataseCytoplasmic, "ErkPhosphataseCytoplasmicbindingReaction");
	PromoterUnbindingReaction *ErkPhosphataseCytoplasmicunbindingReaction = new PromoterUnbindingReaction(ErkPhosphataseCytoplasmicboundPromoter, ErkPhosphataseCytoplasmicfreePromoter, Sp1Active, ku_ErkPhosphataseCytoplasmic, "ErkPhosphataseCytoplasmicunbindingReaction");
	TranscriptionReaction *ErkPhosphataseCytoplasmictranscriptionReaction = new TranscriptionReaction(ErkPhosphataseCytoplasmicboundPromoter, ErkPhosphataseCytoplasmicmRNA, ktm_ErkPhosphataseCytoplasmic, "ErkPhosphataseCytoplasmictranscriptionReaction");
	RNADegradationReaction *ErkPhosphataseCytoplasmicmRNADegradationReaction = new RNADegradationReaction(ErkPhosphataseCytoplasmicmRNA, kdm_ErkPhosphataseCytoplasmic, "ErkPhosphataseCytoplasmicmRNADegradationReaction");
	ProteinTranslationReaction *ErkPhosphataseCytoplasmictranslationReaction = new ProteinTranslationReaction(ErkPhosphataseCytoplasmicmRNA, ErkPhosphataseCytoplasmic, kt_ErkPhosphataseCytoplasmic, "ErkPhosphataseCytoplasmictranslationReaction");
	UnstableProteinDegradationReaction *ErkPhosphataseCytoplasmicproteinDegradationReaction = new UnstableProteinDegradationReaction(ErkPhosphataseCytoplasmic, kd_ErkPhosphataseCytoplasmic, "ErkPhosphataseCytoplasmicproteinDegradationReaction");

	PromoterBindingReaction *bindingReaction = new PromoterBindingReaction(freePromoter, protein, boundPromoter, kb, "PromoterBindingReaction");
	PromoterUnbindingReaction *unbindingReaction = new PromoterUnbindingReaction(boundPromoter, freePromoter, protein, ku, "unbindingReaction");
	TranscriptionReaction *transcriptionReaction = new TranscriptionReaction(boundPromoter, mRNA, ktm, "transcriptionReaction");
	RNADegradationReaction *mRNADegradationReaction = new RNADegradationReaction(mRNA, kdm, "mRNADegradationReaction");
	ProteinTranslationReaction *translationReaction = new ProteinTranslationReaction(mRNA, protein, kt, "translationReaction");
	UnstableProteinDegradationReaction *proteinDegradationReaction = new UnstableProteinDegradationReaction(protein, kd, "proteinDegradationReaction");

	reactions.push_back(EGFBindingReaction);
	reactions.push_back(EGFUnbindingReaction);
	reactions.push_back(NGFBindingReaction);
	reactions.push_back(NGFUnbindingReaction);

	reactions.push_back(SosActivationByEGFReaction);
	reactions.push_back(SosActivationByNGFReaction);
	reactions.push_back(SosDeactivationReaction);
	reactions.push_back(RasActivationReaction);
	reactions.push_back(RasDeactivationReaction);
	reactions.push_back(Raf1ByRasActivationReaction);

	reactions.push_back(MekbyRaf1ActivationReaction);
	reactions.push_back(MekbyBRafActivationReaction);
	reactions.push_back(MekDeactivationReaction);
	reactions.push_back(ErkActivationCytoplasmicReaction);
	reactions.push_back(ErkDeactivationCytoplasmicReaction);
//	reactions.push_back(ErkDeactivationCytoplasmicReaction2);
	reactions.push_back(P90RskActivationReaction);

	reactions.push_back(PI3KEGFActivationReaction);
	reactions.push_back(PI3KRasActivationReaction);
	reactions.push_back(PI3KDeactivationReaction);
	reactions.push_back(AktActivationReaction);
	reactions.push_back(AktDeactivationReaction);
	reactions.push_back(Raf1ByAktDeactivationReaction);

	reactions.push_back(RapGEFActivationReaction);
	reactions.push_back(RapGEFDeactivationReaction);
	reactions.push_back(RapActivationReaction);
	reactions.push_back(RapDeactivationReaction);
	reactions.push_back(BRafByRapActivationReaction);
	reactions.push_back(Raf1ByRapDeactivationReaction);

	reactions.push_back(ErkActiveNuclearTranslocationReaction);
	reactions.push_back(ErkActiveCytoplasmicTranslocationReaction);
	reactions.push_back(ErkActiveNuclearDephosphorylationReaction);

	reactions.push_back(Sp1ActivationReaction);
	reactions.push_back(Sp1DeactivationReaction);

	reactions.push_back(CyclinDbindingReaction);
	reactions.push_back(CyclinDunbindingReaction);
	reactions.push_back(CyclinDtranscriptionReaction);
	reactions.push_back(CyclinDmRNADegradationReaction);
	reactions.push_back(CyclinDtranslationReaction);
	reactions.push_back(CyclinDproteinDegradationReaction);

	reactions.push_back(P21bindingReaction);
	reactions.push_back(P21unbindingReaction);
	reactions.push_back(P21transcriptionReaction);
	reactions.push_back(P21mRNADegradationReaction);
	reactions.push_back(P21translationReaction);
	reactions.push_back(P21proteinDegradationReaction);

	reactions.push_back(CFosbindingReaction);
	reactions.push_back(CFosunbindingReaction);
	reactions.push_back(CFostranscriptionReaction);
	reactions.push_back(CFosmRNADegradationReaction);
	reactions.push_back(CFostranslationReaction);
	reactions.push_back(CFosproteinDegradationReaction);

	reactions.push_back(ErkPhosphataseCytoplasmicbindingReaction);
	reactions.push_back(ErkPhosphataseCytoplasmicunbindingReaction);
	reactions.push_back(ErkPhosphataseCytoplasmictranscriptionReaction);
	reactions.push_back(ErkPhosphataseCytoplasmicmRNADegradationReaction);
	reactions.push_back(ErkPhosphataseCytoplasmictranslationReaction);
	reactions.push_back(ErkPhosphataseCytoplasmicproteinDegradationReaction);

	reactions.push_back(bindingReaction);
	reactions.push_back(unbindingReaction);
	reactions.push_back(transcriptionReaction);
	reactions.push_back(mRNADegradationReaction);
	reactions.push_back(translationReaction);
	reactions.push_back(proteinDegradationReaction);
}

ErkSubnetwork::~ErkSubnetwork()
{
	
}
