// ForcesObserver.cpp: implementation of the ForcesObserver class.
//
//////////////////////////////////////////////////////////////////////

#include "ForcesObserver.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CForcesObserver::CForcesObserver()
{

}

CForcesObserver::~CForcesObserver()
{

}

// default behavior is to print plain text matrix seperated by single spaces

void CForcesObserver::Update(Subject *theChangedSubject)
{
	int i;
	int j;
	int NParameters;
	int m_iNResiduals;
	// static cast may be dangerous
	CImprovedLevenbergMarquardtMinimizer *LM = (CImprovedLevenbergMarquardtMinimizer *)theChangedSubject;

	// write the experimental data to the temporary file
	fstream *forcefile = new fstream("ForceMatrix.dat",ios::out);

	NParameters = LM->GetNParameters();
	m_iNResiduals = LM->GetNResiduals();
	for (i=0; i < NParameters; i++) {
		for (j=0; j < m_iNResiduals; j++) {
			*forcefile << setprecision(10) << LM->GetForceMatrix()[i][j] << "\t";
	    }
	    *forcefile << endl;
	}

	delete forcefile;

	return;
}
