// GnuPlotterCostObserver.cpp: implementation of the GnuPlotterCostObserver class.
//
//////////////////////////////////////////////////////////////////////

#include "GnuPlotterCostObserver.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GnuPlotterCostObserver::GnuPlotterCostObserver()
{

}

GnuPlotterCostObserver::~GnuPlotterCostObserver()
{

}

void GnuPlotterCostObserver::Update(Subject *theChangedSubject)
{
	// static cast may be dangerous
	CStochasticSensitivityAnalysis *analysis = (CStochasticSensitivityAnalysis *)theChangedSubject;
	// set the plot title
	char titlestring[100];
	char commandstring[1000];
	sprintf(titlestring,"set title \"%s\"\n",title);
	SendPlotCommand(titlestring);
	SendPlotCommand("set grid\n");
	SendPlotCommand("set nokey\n");
	SendPlotCommand("set xlabel \"Ensemble Index\"\n");
	SendPlotCommand("set ylabel \"Rescaled Cost\"\n");

	// write the data to the temporary file
	freopen(buffername,"w",buffer);

	for(int i = 0; i < analysis->GetEnsemble()->size(); i++)
	{	
		double cost = analysis->GetEnsemble()->at(i)->GetCost();
		int nResid = analysis->GetEnsemble()->at(i)->GetResidualsSize();
		fprintf(buffer,"%i\t\t%e\n",i,cost*nResid);
	}
	fprintf(buffer,"\n\n");
	fflush(buffer);

	// now start sending plot strings
	sprintf(commandstring,"plot \"%s\" w linespoints\n",buffername);

	// change single backslashes to forward slashes to keep windows happy
#ifdef _WIN32
	int iterator = 0;
	while(commandstring[iterator] != '\0')
	{
		if(commandstring[iterator] == '\\') {commandstring[iterator] = '/';}
		iterator++;
	}
#endif

	SendPlotCommand(commandstring);

	return;
}
