// GnuPlotterResidualScatterPlot.cpp: implementation of the GnuPlotterResidualScatterPlot class.
//
//////////////////////////////////////////////////////////////////////

#include "GnuPlotterResidualScatterPlot.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GnuPlotterResidualScatterPlot::GnuPlotterResidualScatterPlot()
{

}

GnuPlotterResidualScatterPlot::~GnuPlotterResidualScatterPlot()
{

}

void GnuPlotterResidualScatterPlot::Update(Subject *theChangedSubject)
{
	// static case may be dangerous
	CStochasticSensitivityAnalysis *analysis = (CStochasticSensitivityAnalysis *)theChangedSubject;
	int nResid = analysis->GetEnsemble()->at(0)->GetResidualsSize();

	// set the plot title
	char titlestring[100];
	char commandstring[1000];
	sprintf(titlestring,"set title \"%s\"\n",title);
	SendPlotCommand(titlestring);
	SendPlotCommand("set grid\n");
	SendPlotCommand("set nokey\n");
	SendPlotCommand("set xlabel \"i\"\n");
	SendPlotCommand("set ylabel \"Residual i\"\n");

	freopen(buffername,"w",buffer);

	for(int i = 0; i < analysis->GetEnsemble()->size(); i++)
	{
		for(int j = 0; j < nResid; j++)
		{
			fprintf(buffer,"%i\t\t%e\n",j,analysis->GetEnsemble()->at(i)->GetResidual(j));
		}
	}
	fprintf(buffer,"\n\n");
	fflush(buffer);

	sprintf(commandstring,"plot \"%s\" index 0 t \"residuals\" w points\n",buffername);
	
	// change single backslashes to forward slashes to keep windows happy
#ifdef _WIN32
	int iterator = 0;
	while(commandstring[iterator] != '\0')
	{
		if(commandstring[iterator] == '\\') {commandstring[iterator] = '/';}
		iterator++;
	}
#endif

	SendPlotCommand(commandstring);

	return;

}