// LowDimensionalCostFunctionMapper.h: interface for the CLowDimensionalCostFunctionMapper class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LOWDIMENSIONALCOSTFUNCTIONMAPPER_H__5F61AB2F_FFB4_48BF_ABDB_620B14E4CEC4__INCLUDED_)
#define AFX_LOWDIMENSIONALCOSTFUNCTIONMAPPER_H__5F61AB2F_FFB4_48BF_ABDB_620B14E4CEC4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <fstream.h>
#include "../src/Minimizable.h"
#include "../src/ParameterFilter.h"
#include "../src/MatrixOperations.h"


class CLowDimensionalCostFunctionMapper  
{
public:
	CLowDimensionalCostFunctionMapper();
	virtual ~CLowDimensionalCostFunctionMapper();
	// computes the cost along a line joining p1 and p2; (a,b) = (0,1) corresponds to 
	// the line segment starting at p1 and ending at p2
	void Map(Minimizable *pMin,CParameterFilter *pFilter, double *p1, double *p2, double a, double b, int nPts);
	// computes the cost in the plane formed by p1,p2,and p3. (a,b,c,d) = (0,1,0,1) 
	// corresponds to the quadrilateral with p1, p2, and p3 at three of the vertices
	void Map(Minimizable *pMin,CParameterFilter *pFilter, double *p1, double *p2, double *p3, double a, double b, double c, double d, int nPts);
private:
	CMatrixOperations *m_pMO;
};

#endif // !defined(AFX_LOWDIMENSIONALCOSTFUNCTIONMAPPER_H__5F61AB2F_FFB4_48BF_ABDB_620B14E4CEC4__INCLUDED_)
