// MDOChemical.cpp: implementation of the CMDOChemical class.
//
//////////////////////////////////////////////////////////////////////

#include "MDOChemical.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMDOChemical::CMDOChemical(int chemicalNumber, std::string name, std::vector<Chemical *> chemRefVector, std::vector<RateConstant *> rateRefVector)
:CAlgebraicChemical(chemicalNumber,name,chemRefVector,rateRefVector)
{

}

CMDOChemical::~CMDOChemical()
{

}

void CMDOChemical::ComputeAmount()
{
	double temp = 0.0;
	temp = m_vpRateRefVector[2]->GetValue()*(m_vpChemRefVector[0]->GetAmount()/m_vpChemRefVector[0]->GetInitialAmount());
	temp -= m_vpRateRefVector[0]->GetValue();
	temp -= m_vpRateRefVector[1]->GetValue();
	amount = temp;
}

void CMDOChemical::ComputeInitialAmount()
{
	double temp = 0.0;
	temp = m_vpRateRefVector[2]->GetValue() - m_vpRateRefVector[0]->GetValue() - m_vpRateRefVector[1]->GetValue();
	initialAmount = temp;
}

void CMDOChemical::ComputeErrorInInitialAmount()
{
	// temporary
	errorInInitialAmount = 1.0;
}
