// NormalizedLinearAmplifier.h: interface for the CNormalizedLinearAmplifier class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NORMALIZEDLINEARAMPLIFIER_H__9E4C9D75_512D_4912_BBAF_87222F4AFC08__INCLUDED_)
#define AFX_NORMALIZEDLINEARAMPLIFIER_H__9E4C9D75_512D_4912_BBAF_87222F4AFC08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\Reaction.h"

class CNormalizedLinearAmplifier : public Reaction  
{
public:
	CNormalizedLinearAmplifier(Chemical *InputChemical, Chemical *OutputChemical, RateConstant *k_amp, std::string reactionName);
	virtual ~CNormalizedLinearAmplifier();
	double GetRate() const;
	std::vector<JElement *> *GetChemicalJacobian();
	void SetTeXForm();
protected:
	int k_amp;
	int InputChemical;
	int OutputChemical;

};

#endif // !defined(AFX_NORMALIZEDLINEARAMPLIFIER_H__9E4C9D75_512D_4912_BBAF_87222F4AFC08__INCLUDED_)
