// ParameterRandomizer.cpp: implementation of the CParameterRandomizer class.
//
//////////////////////////////////////////////////////////////////////

#include "ParameterRandomizer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CParameterRandomizer::CParameterRandomizer(int seed)
{
	m_iSeed = seed;
	m_pRNG = new Rand(seed);
}

CParameterRandomizer::~CParameterRandomizer()
{
	delete m_pRNG;
}

void CParameterRandomizer::Randomize(double *parameters, int nParameters, double fraction, int nIterations)
{
	if(fraction > 1.0)
	{
		fraction = 1.0;
	}
	if(fraction < 0.0)
	{
		fraction = 0.0;
	}

	for(int iCount = 0; iCount < nIterations; iCount++)
	{
		for(int i = 0; i < nParameters; i++)
		{
			parameters[i] += (-1 + 2*(m_pRNG->uniform()))*fraction*parameters[i];
		}
	}
}
