// SharedPC12NetworksMinimizableDirector.cpp: implementation of the CSharedPC12NetworksMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#include "SharedPC12NetworksMinimizableDirector.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSharedPC12NetworksMinimizableDirector::CSharedPC12NetworksMinimizableDirector()
{
	// replica one
	m_pReplicaOne = new PC12EGFNGFMinimizableDirector();
	// replica two
	m_pReplicaTwo = new CPC12AlternateMinimizableDirector();

	// find the parameter intersection lists
	SetIntersectionLists();

	// allocate the master residuals list
	int masterResidualsSize = 0;
	masterResidualsSize = m_pReplicaOne->GetNResiduals() + m_pReplicaTwo->GetNResiduals();
	if(m_dGammaSquared > 0.0)
	{
		masterResidualsSize += 1;
	}
	Allocate(masterResidualsSize);

	cout << "Master Residuals size : " << masterResidualsSize << endl;
}

CSharedPC12NetworksMinimizableDirector::~CSharedPC12NetworksMinimizableDirector()
{

}
