// SharedParametersMinimizableDirector.h: interface for the CSharedParametersMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHAREDPARAMETERSMINIMIZABLEDIRECTOR_H__D78A7250_B952_4C4E_94EF_66E6B4AE2740__INCLUDED_)
#define AFX_SHAREDPARAMETERSMINIMIZABLEDIRECTOR_H__D78A7250_B952_4C4E_94EF_66E6B4AE2740__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// Need something fancy to make sure parameters get put in the right
// place, since intersected parameters and unique parameters will be
// interleaved.

#include "..\SRC\NetworkMinimizableDirector.h"

class CSharedParametersMinimizableDirector : public NetworkMinimizableDirector  
{
public:
	CSharedParametersMinimizableDirector();
	virtual ~CSharedParametersMinimizableDirector();
	// returns NP_1 + NP_2 - N_Intersect(P_1,P_2)
	int GetNParameters();
	double ComputeResiduals(double *parameters);
	double GetParameter(int parIndex);
	// sets up the appropriate intesection lists for the two models so
	// we know which parameters are common
	void SetIntersectionLists();
private:
	virtual void DefineExperiments() {return;}
protected:
	NetworkMinimizableDirector *m_pReplicaOne;
	NetworkMinimizableDirector *m_pReplicaTwo;
	intVector m_viIntersectOne;
	intVector m_viIntersectTwo;
};

#endif // !defined(AFX_SHAREDPARAMETERSMINIMIZABLEDIRECTOR_H__D78A7250_B952_4C4E_94EF_66E6B4AE2740__INCLUDED_)
