#include "SloppyDataMinimizableDirector.h"

CSloppyDataMinimizableDirector::CSloppyDataMinimizableDirector(void)
{
}

CSloppyDataMinimizableDirector::~CSloppyDataMinimizableDirector(void)
{
	int i;
	for(i = 0; i < m_vpRelationList.size(); i++)
	{
		delete m_vpRelationList[i];
	}
}

double CSloppyDataMinimizableDirector::ObjectiveFunction(double *parameters)
{
	double totalC = 0.0;
	return totalC;
}

void CSloppyDataMinimizableDirector::ParseDataFile(std::string fileName)
{
	int i = 0;
	bool isEqual;
	// used for reading in the data
	char lineBuf[1000];
	char rname1[100],rname2[100],cname1[100],cname2[100];
	char type;
	double time1,time2;

	int r1,r2,q1,q2;

	// open the file for reading
	ifstream dataFile(fileName.c_str());
	assert(dataFile);
	
	// put the data line by line into the linebuffer and then parse it
	while(dataFile.getline(lineBuf,sizeof(lineBuf)))
	{
		if(lineBuf[0] == '%') {continue;}
		istrstream dataStream(lineBuf);
		dataStream >> rname1 >> cname1 >> time1 >> rname2 >> cname2 >> time2 >> type;

		// find where network one goes
		std::string n1(rname1);
		for(i = 0; i < m_vpRunnables.size(); i++)
		{
			isEqual = (n1 == m_vpRunnables[i]->GetRunnableName());
			if(isEqual) {break;}
		}
		r1 = i;
		// find where the first quantity is present in that runnable
		std::string c1(cname1);
		for(i = 0; i < m_vpRunnables[r1]->GetReactionNetwork()->GetNumberOfChemicals(); i++)
		{
			isEqual = (c1 == m_vpRunnables[i]->GetReactionNetwork()->GetChemical(i)->GetName());
			if(isEqual) {break;}
		}
		q1 = i;

		// now repeat for the second half of the line

		// find where network two goes
		std::string n2(rname2);
		for(i = 0; i < m_vpRunnables.size(); i++)
		{
			isEqual = (n2 == m_vpRunnables[i]->GetRunnableName());
			if(isEqual) {break;}
		}
		r2 = i;
		// find where the second quantity is present in that runnable
		std::string c2(cname2);
		for(i = 0; i < m_vpRunnables[r2]->GetReactionNetwork()->GetNumberOfChemicals(); i++)
		{
			isEqual = (c2 == m_vpRunnables[i]->GetReactionNetwork()->GetChemical(i)->GetName());
			if(isEqual) {break;}
		}
		q2 = i;
		
		// create a binary relation and put it in the right place
		m_vpRelationList.push_back(new CBinaryNetworkDataRelation(r1,q1,(int)time1,r2,q2,(int)time2,type));
	}

	
	return;
}
