// TauNetwork.h: interface for the CTauNetwork class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TAUNETWORK_H__B552F72A_B916_4F52_8476_3A60F2CFC564__INCLUDED_)
#define AFX_TAUNETWORK_H__B552F72A_B916_4F52_8476_3A60F2CFC564__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\ReactionNetwork.h"
#include "..\src_temp\MixedReactionNetwork.h"
#include "..\src_ac\TauReaction.h"

class CTauNetwork : public ReactionNetwork  
{
public:
	CTauNetwork();
	CTauNetwork(CMixedReactionNetwork *pMixedNetwork);
	virtual ~CTauNetwork();
	int GetNumberOfChemicals() const;
	int GetNumberOfReactions() const;
	Chemical *GetChemical(int chemicalNumber);
	virtual std::vector<double> *GetReactionRates();
	virtual std::vector<Reaction*> *GetReactions();
	virtual std::vector<Chemical*> *GetChemicals();
	double GetTOfTau() const;
protected:
	CMixedReactionNetwork *m_pMixedNetwork;
	Chemical *m_pChemTau;
	Reaction *m_pRxnTauReaction;
};

#endif // !defined(AFX_TAUNETWORK_H__B552F72A_B916_4F52_8476_3A60F2CFC564__INCLUDED_)
