// TrimerFormation.h: interface for the CTrimerFormation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRIMERFORMATION_H__DBFFA65A_08FF_4285_B6E9_94E46A6639FD__INCLUDED_)
#define AFX_TRIMERFORMATION_H__DBFFA65A_08FF_4285_B6E9_94E46A6639FD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\Reaction.h"

class CTrimerFormation : public Reaction  
{
public:
	CTrimerFormation(Chemical *A, Chemical *B, Chemical *C, Chemical *Trimer, RateConstant *k_t, std::string reactionName);
	virtual ~CTrimerFormation();
	double GetRate() const;
	std::vector<JElement *> *GetChemicalJacobian();
	void SetTeXForm();
protected:
	int k_t;
	int A,B,C,Trimer;

};

#endif // !defined(AFX_TRIMERFORMATION_H__DBFFA65A_08FF_4285_B6E9_94E46A6639FD__INCLUDED_)
