// XYVector.cpp: implementation of the CXYVector class.
//
//////////////////////////////////////////////////////////////////////

#include "XYVector.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CXYVector::CXYVector()
{

}

CXYVector::~CXYVector()
{
	for(int i = 0; i < m_vpXYVector.size(); i++)
	{
		delete m_vpXYVector[i];
	}
}

void CXYVector::SetXYPair(int n, double x, double y)
{
	if(n > m_vpXYVector.size())
	{
		return;
	}
	
	m_vpXYVector[n]->SetX(x);
	m_vpXYVector[n]->SetY(y);
}

void CXYVector::AddXYPoint(double x, double y)
{
	m_vpXYVector.push_back(new CXYPoint(x,y));
}

void CXYVector::SortOnX()
{
	// use STL sort with the correct comparator
	CXYPoint::CXComparator xcomp;
	std::sort(m_vpXYVector.begin(),m_vpXYVector.end(),xcomp);
}

void CXYVector::SortOnY()
{
	// use STL sort with the correct comparator
	CXYPoint::CYComparator ycomp;
	std::sort(m_vpXYVector.begin(),m_vpXYVector.end(),ycomp);
}
