#include <iostream.h>
#include <string.h>
#include "GeneticCode.h"

const int GeneticCode::NUM_ANTICODONS = 33;

const int GeneticCode::NUM_CODONS = 64;

// destructor
GeneticCode::~GeneticCode()
{
	delete [] code;
}

// constructor
GeneticCode::GeneticCode()
{
	code = new int[NUM_CODONS];

  code[int(AAA)] = int(uuu);  // lys
  code[int(AAG)] = int(uuu);  // lys
  code[int(AAU)] = int(quu);  // asn
  code[int(AAC)] = int(quu);  // asn
  code[int(AUU)] = int(gau);  // ile
  code[int(AUC)] = int(gau);  // ile
  code[int(AUA)] = int(nau);  // ile
  code[int(AUG)] = int(cau);  // met
  code[int(CGU)] = int(icg);  // arg
  code[int(CGC)] = int(icg);  // arg
  code[int(CGA)] = int(icg);  // arg
  code[int(CGG)] = int(ccg);  // arg
  code[int(AGA)] = int(ucu);  // arg
  code[int(AGG)] = int(ucu);  // arg
  code[int(UCU)] = int(gga);  // ser
  code[int(UCC)] = int(gga);  // ser
  code[int(UCA)] = int(gga);  // ser
  code[int(UCG)] = int(gga);  // ser
  code[int(AGU)] = int(gcu);  // ser
  code[int(AGC)] = int(gcu);  // ser
  code[int(ACU)] = int(ggu);  // thr
  code[int(ACC)] = int(ggu);  // thr
  code[int(ACA)] = int(ugu);  // thr
  code[int(ACG)] = int(ugu);  // thr
  code[int(UGG)] = int(cca);  // trp
  code[int(UAU)] = int(qua);  // tyr
  code[int(UAC)] = int(qua);  // tyr
  code[int(CUU)] = int(gag);  // leu
  code[int(CUC)] = int(gag);  // leu
  code[int(CUA)] = int(uag);  // leu
  code[int(CUG)] = int(cag);  // leu
  code[int(UUA)] = int(aaa);  // leu
  code[int(UUG)] = int(aaa);  // leu
  code[int(UUU)] = int(gaa);  // phe
  code[int(UUC)] = int(gaa);  // phe
  code[int(UGU)] = int(gca);  // cys
  code[int(UGC)] = int(gca);  // cys
  code[int(GAA)] = int(uuc);  // glu
  code[int(GAG)] = int(uuc);  // glu
  code[int(GAU)] = int(quc);  // asp
  code[int(GAC)] = int(quc);  // asp
  code[int(GUU)] = int(gac);  // val
  code[int(GUC)] = int(gac);  // val
  code[int(GUA)] = int(gac);  // val
  code[int(GUG)] = int(gac);  // val
  code[int(GGU)] = int(gcc);  // gly
  code[int(GGC)] = int(gcc);  // gly
  code[int(GGA)] = int(ucc);  // gly
  code[int(GGG)] = int(ccc);  // gly
  code[int(GCU)] = int(ggc);  // ala
  code[int(GCC)] = int(ggc);  // ala
  code[int(GCA)] = int(ggc);  // ala
  code[int(GCG)] = int(ggc);  // ala
  code[int(CAA)] = int(uug);  // gln
  code[int(CAG)] = int(cug);  // gln
  code[int(CAU)] = int(qug);  // his
  code[int(CAC)] = int(qug);  // his
  code[int(CCU)] = int(qgg);  // pro
  code[int(CCC)] = int(qgg);  // pro
  code[int(CCA)] = int(ugg);  // pro
  code[int(CCG)] = int(ugg);  // pro

  code[int(UAA)] = int(stop);  // stop
  code[int(UAG)] = int(stop);  // stop
  code[int(UGA)] = int(stop);  // stop
}

Anticodon GeneticCode::get_anticodon(Codon x)
{
  return Anticodon(code[int(x)]);
}

Codon GeneticCode::read_seq(char* seq)
{
  if (strncmp(seq, "AAA", 3) == 0)
    return AAA;
  else if (strncmp(seq, "AAU", 3) == 0)
    return AAU;
  else if (strncmp(seq, "AAG", 3) == 0)
    return AAG;
  else if (strncmp(seq, "AAC", 3) == 0)
    return AAC;
  else if (strncmp(seq, "AUA", 3) == 0)
    return AUA;
  else if (strncmp(seq, "AUU", 3) == 0)
    return AUU;
  else if (strncmp(seq, "AUG", 3) == 0)
    return AUG;
  else if (strncmp(seq, "AUC", 3) == 0)
    return AUC;
  else if (strncmp(seq, "AGA", 3) == 0)
    return AGA;
  else if (strncmp(seq, "AGU", 3) == 0)
    return AGU;
  else if (strncmp(seq, "AGG", 3) == 0)
    return AGG;
  else if (strncmp(seq, "AGC", 3) == 0)
    return AGC;
  else if (strncmp(seq, "ACA", 3) == 0)
    return ACA;
  else if (strncmp(seq, "ACU", 3) == 0)
    return ACU;
  else if (strncmp(seq, "ACG", 3) == 0)
    return ACG;
  else if (strncmp(seq, "ACC", 3) == 0)
    return ACC;
  else if (strncmp(seq, "UAA", 3) == 0)
    return UAA;
  else if (strncmp(seq, "UAU", 3) == 0)
    return UAU;
  else if (strncmp(seq, "UAG", 3) == 0)
    return UAG;
  else if (strncmp(seq, "UAC", 3) == 0)
    return UAC;
  else if (strncmp(seq, "UUA", 3) == 0)
    return UUA;
  else if (strncmp(seq, "UUU", 3) == 0)
    return UUU;
  else if (strncmp(seq, "UUG", 3) == 0)
    return UUG;
  else if (strncmp(seq, "UUC", 3) == 0)
    return UUC;
  else if (strncmp(seq, "UGA", 3) == 0)
    return UGA;
  else if (strncmp(seq, "UGU", 3) == 0)
    return UGU;
  else if (strncmp(seq, "UGG", 3) == 0)
    return UGG;
  else if (strncmp(seq, "UGC", 3) == 0)
    return UGC;
  else if (strncmp(seq, "UCA", 3) == 0)
    return UCA;
  else if (strncmp(seq, "UCU", 3) == 0)
    return UCU;
  else if (strncmp(seq, "UCG", 3) == 0)
    return UCG;
  else if (strncmp(seq, "UCC", 3) == 0)
    return UCC;
  else if (strncmp(seq, "GAA", 3) == 0)
    return GAA;
  else if (strncmp(seq, "GAU", 3) == 0)
    return GAU;
  else if (strncmp(seq, "GAG", 3) == 0)
    return GAG;
  else if (strncmp(seq, "GAC", 3) == 0)
    return GAC;
  else if (strncmp(seq, "GUA", 3) == 0)
    return GUA;
  else if (strncmp(seq, "GUU", 3) == 0)
    return GUU;
  else if (strncmp(seq, "GUG", 3) == 0)
    return GUG;
  else if (strncmp(seq, "GUC", 3) == 0)
    return GUC;
  else if (strncmp(seq, "GGA", 3) == 0)
    return GGA;
  else if (strncmp(seq, "GGU", 3) == 0)
    return GGU;
  else if (strncmp(seq, "GGG", 3) == 0)
    return GGG;
  else if (strncmp(seq, "GGC", 3) == 0)
    return GGC;
  else if (strncmp(seq, "GCA", 3) == 0)
    return GCA;
  else if (strncmp(seq, "GCU", 3) == 0)
    return GCU;
  else if (strncmp(seq, "GCG", 3) == 0)
    return GCG;
  else if (strncmp(seq, "GCC", 3) == 0)
    return GCC;
  else if (strncmp(seq, "CAA", 3) == 0)
    return CAA;
  else if (strncmp(seq, "CAU", 3) == 0)
    return CAU;
  else if (strncmp(seq, "CAG", 3) == 0)
    return CAG;
  else if (strncmp(seq, "CAC", 3) == 0)
    return CAC;
  else if (strncmp(seq, "CUA", 3) == 0)
    return CUA;
  else if (strncmp(seq, "CUU", 3) == 0)
    return CUU;
  else if (strncmp(seq, "CUG", 3) == 0)
    return CUG;
  else if (strncmp(seq, "CUC", 3) == 0)
    return CUC;
  else if (strncmp(seq, "CGA", 3) == 0)
    return CGA;
  else if (strncmp(seq, "CGU", 3) == 0)
    return CGU;
  else if (strncmp(seq, "CGG", 3) == 0)
    return CGG;
  else if (strncmp(seq, "CGC", 3) == 0)
    return CGC;
  else if (strncmp(seq, "CCA", 3) == 0)
    return CCA;
  else if (strncmp(seq, "CCU", 3) == 0)
    return CCU;
  else if (strncmp(seq, "CCG", 3) == 0)
    return CCG;
  else if (strncmp(seq, "CCC", 3) == 0)
    return CCC;
  else
  {
    cout << seq << " is not a valid codon." << endl;
    return UGA;
  }
}

void GeneticCode::write_seq(Codon c, char* str)
{
  if (c==AAA)
    strcpy(str, "AAA");
  else if (c==AAU)
    strcpy(str, "AAU");
  else if (c==AAG)
    strcpy(str, "AAG");
  else if (c==AAC)
    strcpy(str, "AAC");
  else if (c==AUA)
    strcpy(str, "AUA");
  else if (c==AUU)
    strcpy(str, "AUU");
  else if (c==AUG)
    strcpy(str, "AUG");
  else if (c==AUC)
    strcpy(str, "AUC");
  else if (c==AGA)
    strcpy(str, "AGA");
  else if (c==AGU)
    strcpy(str, "AGU");
  else if (c==AGG)
    strcpy(str, "AGG");
  else if (c==AGC)
    strcpy(str, "AGC");
  else if (c==ACA)
    strcpy(str, "ACA");
  else if (c==ACU)
    strcpy(str, "ACU");
  else if (c==ACG)
    strcpy(str, "ACG");
  else if (c==ACC)
    strcpy(str, "ACC");
  else if (c==UAA)
    strcpy(str, "UAA");
  else if (c==UAU)
    strcpy(str, "UAU");
  else if (c==UAG)
    strcpy(str, "UAG");
  else if (c==UAC)
    strcpy(str, "UAC");
  else if (c==UUA)
    strcpy(str, "UUA");
  else if (c==UUU)
    strcpy(str, "UUU");
  else if (c==UUG)
    strcpy(str, "UUG");
  else if (c==UUC)
    strcpy(str, "UUC");
  else if (c==UGA)
    strcpy(str, "UGA");
  else if (c==UGU)
    strcpy(str, "UGU");
  else if (c==UGG)
    strcpy(str, "UGG");
  else if (c==UGC)
    strcpy(str, "UGC");
  else if (c==UCA)
    strcpy(str, "UCA");
  else if (c==UCU)
    strcpy(str, "UCU");
  else if (c==UCG)
    strcpy(str, "UCG");
  else if (c==UCC)
    strcpy(str, "UCC");
  else if (c==GAA)
    strcpy(str, "GAA");
  else if (c==GAU)
    strcpy(str, "GAU");
  else if (c==GAG)
    strcpy(str, "GAG");
  else if (c==GAC)
    strcpy(str, "GAC");
  else if (c==GUA)
    strcpy(str, "GUA");
  else if (c==GUU)
    strcpy(str, "GUU");
  else if (c==GUG)
    strcpy(str, "GUG");
  else if (c==GUC)
    strcpy(str, "GUC");
  else if (c==GGA)
    strcpy(str, "GGA");
  else if (c==GGU)
    strcpy(str, "GGU");
  else if (c==GGG)
    strcpy(str, "GGG");
  else if (c==GGC)
    strcpy(str, "GGC");
  else if (c==GCA)
    strcpy(str, "GCA");
  else if (c==GCU)
    strcpy(str, "GCU");
  else if (c==GCG)
    strcpy(str, "GCG");
  else if (c==GCC)
    strcpy(str, "GCC");
  else if (c==CAA)
    strcpy(str, "CAA");
  else if (c==CAU)
    strcpy(str, "CAU");
  else if (c==CAG)
    strcpy(str, "CAG");
  else if (c==CAC)
    strcpy(str, "CAC");
  else if (c==CUA)
    strcpy(str, "CUA");
  else if (c==CUU)
    strcpy(str, "CUU");
  else if (c==CUG)
    strcpy(str, "CUG");
  else if (c==CUC)
    strcpy(str, "CUC");
  else if (c==CGA)
    strcpy(str, "CGA");
  else if (c==CGU)
    strcpy(str, "CGU");
  else if (c==CGG)
    strcpy(str, "CGG");
  else if (c==CGC)
    strcpy(str, "CGC");
  else if (c==CCA)
    strcpy(str, "CCA");
  else if (c==CCU)
    strcpy(str, "CCU");
  else if (c==CCG)
    strcpy(str, "CCG");
  else if (c==CCC)
    strcpy(str, "CCC");
  else
    cout << "Not a valid codon." << endl;
}
