// BasicMetropolisAnneal.h: interface for the BasicMetropolisAnneal class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASICMETROPOLISANNEAL_H__1D7C4DE3_0B55_4D04_A93C_D70A7324DAD5__INCLUDED_)
#define AFX_BASICMETROPOLISANNEAL_H__1D7C4DE3_0B55_4D04_A93C_D70A7324DAD5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../src_temp/SimulatedAnnealingStrategy.h"

class BasicMetropolisAnneal : public CSimulatedAnnealingStrategy  
{
public:
	BasicMetropolisAnneal(int nEquilibrationSteps,int RNGSeed=1,double alpha=0.9);
	virtual ~BasicMetropolisAnneal();
	virtual void InitializeTemperature(double *parameters, Minimizable *minimizable);
	virtual void GenerateMove(double *pTrialParameters);
	virtual bool AcceptMove(double Eold,double Enew);
	virtual void Cool();
	virtual bool Terminate();
private:
	// double previousEmin;
	double alpha;
};

#endif // !defined(AFX_BASICMETROPOLISANNEAL_H__1D7C4DE3_0B55_4D04_A93C_D70A7324DAD5__INCLUDED_)
