// BasicQuenchMinimizer.h: interface for the CBasicQuenchMinimizer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BASICQUENCHMINIMIZER_H__87968086_C797_47B5_9824_87948AB93E4C__INCLUDED_)
#define AFX_BASICQUENCHMINIMIZER_H__87968086_C797_47B5_9824_87948AB93E4C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../src_temp/SimulatedAnnealingStrategy.h"

class CBasicQuenchMinimizer : public CSimulatedAnnealingStrategy  
{
public:
	CBasicQuenchMinimizer(int nTrialSteps, int nCycles, double initialStepScale, int seed, CParameterFilter *pFilter);
	virtual ~CBasicQuenchMinimizer();
	virtual void InitializeTemperature(Minimizable *minimizable);
	virtual void GenerateMove();
	virtual bool AcceptMove(double Eold,double Enew);
	virtual void Cool();
	virtual bool Terminate();
	virtual bool Equilibrated();
private:
	double m_dStepScale;
	double m_dInitialStepScale;
	int m_iNCycles;
	int m_iNTrialSteps;
};

#endif // !defined(AFX_BASICQUENCHMINIMIZER_H__87968086_C797_47B5_9824_87948AB93E4C__INCLUDED_)
