// EnsembleRunDirector.h: interface for the CEnsembleRunDirector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ENSEMBLERUNDIRECTOR_H__34F97A37_EFEC_4BE8_B7D7_B84B2BCE85EF__INCLUDED_)
#define AFX_ENSEMBLERUNDIRECTOR_H__34F97A37_EFEC_4BE8_B7D7_B84B2BCE85EF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <cmath>
#include "..\SRC_TEMP\RunDirector.h"
#include "..\src\ParameterReader.h"
#include "..\src_temp\GnuPlotterEnsembleRunDirectorObserver.h"

class GnuPlotterEnsembleRunDirectorObserver; // Both files refer to one another

class CEnsembleRunDirector : public CRunDirector  
{
public:
	CEnsembleRunDirector(int ensembleSize);
	virtual ~CEnsembleRunDirector();
	void LoadEnsembleInfo(std::string parameterFile);
	void SumAllocate();
	void Execute();
	void ConvertToStatistics();
	const double **GetAverages(int index) const {return (const double **)m_vpdSumC[index];}
	const double **GetStdDevs(int index) const {return (const double **)m_vpdSumCSqr[index];}
protected:
	int m_iEnsembleSize;
	std::vector<double *> m_vpdEnsembleParameters;
	std::vector<double **> m_vpdSumC;
	std::vector<double **> m_vpdSumCSqr;
	std::vector<GnuPlotterEnsembleRunDirectorObserver *> m_vpEnsemblePlotters;
};

#endif // !defined(AFX_ENSEMBLERUNDIRECTOR_H__34F97A37_EFEC_4BE8_B7D7_B84B2BCE85EF__INCLUDED_)
