// EvolutionStrategyChromosome.cpp: implementation of the CEvolutionStrategyChromosome class.
//
//////////////////////////////////////////////////////////////////////

#include "EvolutionStrategyChromosome.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CEvolutionStrategyChromosome::CEvolutionStrategyChromosome(int nObject, int nStrategy)
{
	m_iNObjectParameters = nObject;
	m_iNStrategyParameters = nStrategy;
	m_pdObjectParameters = new double[nObject];
	m_pdStrategyParameters = new double[nStrategy];
}

CEvolutionStrategyChromosome::~CEvolutionStrategyChromosome()
{
	if(0 != m_pdObjectParameters) delete [] m_pdObjectParameters;
	if(0 != m_pdStrategyParameters) delete [] m_pdStrategyParameters;
}

void CEvolutionStrategyChromosome::SetObjectParameters(double *newOPs)
{
	for(int i = 0; i < m_iNObjectParameters; i++)
	{
		m_pdObjectParameters[i] = newOPs[i];
	}
}

void CEvolutionStrategyChromosome::SetStrategyParameters(double *newSPs)
{
	for(int i = 0; i < m_iNStrategyParameters; i++)
	{
		m_pdStrategyParameters[i] = newSPs[i];
	}
}
