// EvolutionStrategyChromosome.h: interface for the CEvolutionStrategyChromosome class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EVOLUTIONSTRATEGYCHROMOSOME_H__1E22383C_E578_4EDE_B401_FEC45761A74F__INCLUDED_)
#define AFX_EVOLUTIONSTRATEGYCHROMOSOME_H__1E22383C_E578_4EDE_B401_FEC45761A74F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CEvolutionStrategyChromosome  
{
public:
	CEvolutionStrategyChromosome(int nObject, int nStrategy);
	virtual ~CEvolutionStrategyChromosome();
	int GetNObjectParameters() {return m_iNObjectParameters;}
	int GetNStrategyParameters() {return m_iNStrategyParameters;}
	void SetObjectParameters(double *newOPs);
	void SetStrategyParameters(double *newSPs);
	void SetObjFuncValue(double newVal) {m_dObjFuncValue = newVal;}
	double GetObjectParameter(int index) {return m_pdObjectParameters[index];}
	double GetStrategyParameter(int index) {return m_pdStrategyParameters[index];}
	double GetObjFuncValue() {return m_dObjFuncValue;}
	double *GetObjectParameters() {return m_pdObjectParameters;}
	double *GetStrategyParameters() {return m_pdStrategyParameters;}
	// necessary to sort a vector of pointers to chromosomes
	class CEvolutionStrategyChromosomeComparator
	{
	public:
		CEvolutionStrategyChromosomeComparator() {return;}
		virtual ~CEvolutionStrategyChromosomeComparator() {return;}
		bool operator()(CEvolutionStrategyChromosome *c1, CEvolutionStrategyChromosome *c2) 
		{
			return c1->GetObjFuncValue() < c2->GetObjFuncValue();
		}
	};
private:
	double m_dObjFuncValue;
	int m_iNObjectParameters;
	int m_iNStrategyParameters;
	double *m_pdObjectParameters;
	double *m_pdStrategyParameters;
};

#endif // !defined(AFX_EVOLUTIONSTRATEGYCHROMOSOME_H__1E22383C_E578_4EDE_B401_FEC45761A74F__INCLUDED_)
