// GnuPlotterRunnableObserver.cpp: implementation of the GnuPlotterRunnableObserver class.
//
//////////////////////////////////////////////////////////////////////

#include "GnuPlotterRunnableObserver.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GnuPlotterRunnableObserver::GnuPlotterRunnableObserver()
{

}

GnuPlotterRunnableObserver::~GnuPlotterRunnableObserver()
{

}

void GnuPlotterRunnableObserver::AddChemicalNumberToList(int chemNumber)
{
	m_viChemNumbers.push_back(chemNumber);
}

void GnuPlotterRunnableObserver::Update(Subject *theChangedSubject)
{
	// static cast may be dangerous
	CRunnable *pRunnable = (CRunnable *)theChangedSubject; 

	// reopen the temp file
	freopen(buffername,"w",buffer);

	int maxTime = pRunnable->GetCellObserver()->GetNumberOfTimeSteps();
	char titlestring[1000],commandstring[1000];

	// dump the time series data for the chemicals to the temp file
	for(int i = 0; i < m_viChemNumbers.size(); i++)
	{
		for(int t = 0; t < (maxTime-1); t++)
		{
			double time = double (t);
			double sim = pRunnable->GetCellObserver()->GetAverageConcentration()[m_viChemNumbers[i]][t];
			fprintf(buffer,"%e\t\t%e\n",time,sim);
		}
		// pad each series with two newlines
		fprintf(buffer,"\n\n");
	}

	sprintf(titlestring,"set title \"%s\"\n",title);
	SendPlotCommand(titlestring);
	SendPlotCommand("set grid\n");
	SendPlotCommand("set xlabel \"time (min)\"\n");
	SendPlotCommand("set ylabel \"[Chemical] (molecules)\"\n");
	SendPlotCommand("set key\n");
	// plot the first chemical manually
	char namestring[200];
	sprintf(namestring,pRunnable->GetReactionNetwork()->GetChemical(m_viChemNumbers[0])->GetName().c_str());
	sprintf(commandstring,"plot \"%s\" index 0 t \"%s\" w lines lw 4",buffername,namestring);
	// the rest
	for(i = 1; i < m_viChemNumbers.size(); i++)
	{
		char tempbuffer[500];
		sprintf(namestring,pRunnable->GetReactionNetwork()->GetChemical(m_viChemNumbers[i])->GetName().c_str());
		sprintf(tempbuffer,",\"%s\" index %i t \"%s\" w lines lw 4",buffername,i,namestring);
		strcat(commandstring,tempbuffer);
	}
	strcat(commandstring,"\n");
	fflush(buffer);
	
	// change single backslashes to forward slashes to keep windows happy
#ifdef _WIN32
	int iterator = 0;
	while(commandstring[iterator] != '\0')
	{
		if(commandstring[iterator] == '\\') {commandstring[iterator] = '/';}
		iterator++;
	}
#endif
	
	SendPlotCommand(commandstring);
}