// ImprovedLevenbergMarquardtMinimizer.h: interface for the CImprovedLevenbergMarquardtMinimizer class.
//
//////////////////////////////////////////////////////////////////////

// Made UNIX friendly 9/5/02

#if !defined(AFX_IMPROVEDLEVENBERGMARQUARDTMINIMIZER_H__9039A15E_5863_4BEA_B916_644103251249__INCLUDED_)
#define AFX_IMPROVEDLEVENBERGMARQUARDTMINIMIZER_H__9039A15E_5863_4BEA_B916_644103251249__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "../src/MatrixOperations.h"
#include "../src/LevenbergMarquardtMinimizer.h"

class CImprovedLevenbergMarquardtMinimizer : public CLevenbergMarquardtMinimizer  
{
public:
	CImprovedLevenbergMarquardtMinimizer();
	CImprovedLevenbergMarquardtMinimizer(CParameterFilter *pFilter, bool psdFlag, double marquardt, bool checkChi, double chiTol, bool checkGrad, double gradTol, bool checkPar, double parTol, int nIterations, double funcAccuracy);
	virtual ~CImprovedLevenbergMarquardtMinimizer();
	double Minimize(double *parameters, Minimizable *minimizable);
	// Solve LM system using Singular Value Decomp.
	void SVDSolveMarquardtSystem(double *deltaP);
private:
	bool m_bChiSqFlag;				// Set to true for convergence on chi-squared
	bool m_bGradFlag;				// Set to true for convergence on ||g||
	bool m_bParFlag;                // Set to true for convergence on parameters
};

#endif // !defined(AFX_IMPROVEDLEVENBERGMARQUARDTMINIMIZER_H__9039A15E_5863_4BEA_B916_644103251249__INCLUDED_)
