// MixedReactionMover.h: interface for the CMixedReactionMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MIXEDREACTIONMOVER_H__2117D24C_7166_498D_BC54_5884EA886F47__INCLUDED_)
#define AFX_MIXEDREACTIONMOVER_H__2117D24C_7166_498D_BC54_5884EA886F47__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MixedReactionNetwork.h"
#include "..\SRC\ReactionMover.h"
#include "..\src\DifferentialEquationMover.h"
#include "..\src\Rand.h"
#include "..\src\typedefs.h"
#include "..\src_ac\TauNetwork.h"


class CMixedReactionMover : public CReactionMover  
{
public:
	CMixedReactionMover();
	CMixedReactionMover(int seed, CDifferentialEquationMover *pODEMover, double absTol);
	virtual ~CMixedReactionMover();
	void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork);
	void DoStochasticMove(double dRand);
private:
	CDifferentialEquationMover *m_pODEMover;
	CMixedReactionNetwork *m_pMixedReactionNetwork;
	CTauNetwork *m_pTauNetwork;
	Rand *m_pRNG;
	// absolute error tolerance
	double m_dAbsTol;
};

#endif // !defined(AFX_MIXEDREACTIONMOVER_H__2117D24C_7166_498D_BC54_5884EA886F47__INCLUDED_)
