// MixedReactionNetwork.h: interface for the CMixedReactionNetwork class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MIXEDREACTIONNETWORK_H__188826DA_57B1_4AC3_96A7_EFEF7F73E12A__INCLUDED_)
#define AFX_MIXEDREACTIONNETWORK_H__188826DA_57B1_4AC3_96A7_EFEF7F73E12A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <algorithm>
#include "..\SRC\ReactionNetwork.h"
#include "..\SRC\typedefs.h"

class CMixedReactionNetwork : public ReactionNetwork  
{
public:
	CMixedReactionNetwork();
	CMixedReactionNetwork(ReactionNetwork *pReactionNetwork, intVector stocReactionList);
	virtual ~CMixedReactionNetwork();
	int GetNumberOfChemicals() const;
	int GetNumberOfReactions() const;
	int GetNumberOfRateConstants() const;
	Chemical *GetChemical(int chemicalNumber);
	RateConstant *GetRateConstant(int rateConstantNumber);
	void ChemicalReset();
	void RateConstantReset();
	void SetAmount(int chemicalNumber, double amount);
	vpReaction *GetReactions();
	Reaction *GetReaction(int reactionNumber);
	vpReaction *GetStochasticReactions();
	Reaction *GetStochasticReaction(int reactionNumber);
	vpReaction *GetDeterministicReactions();
	Reaction *GetDeterministicReaction(int reactionNumber);
	vpChemical *GetChemicals();
	vpRateConstant *GetRateConstants();
	int GetNumberOfStochasticReactions() const;
	int GetNumberOfDeterministicReactions() const;
	dblVector *GetReactionRates();
	dblVector *GetStochasticReactionRates();
	dblVector *GetDeterministicReactionRates();
	double GetTotalStochasticReactionProbability();
private:
	ReactionNetwork *m_pReactionNetwork;
	intVector m_viStochasticList;
	vpReaction m_vpStochasticReactions;
	vpReaction m_vpDeterministicReactions;
	dblVector m_dStochasticReactionRates;
	dblVector m_dDeterministicReactionRates;
};

#endif // !defined(AFX_MIXEDREACTIONNETWORK_H__188826DA_57B1_4AC3_96A7_EFEF7F73E12A__INCLUDED_)
