// ReplicaMinimizableDirector.h: interface for the CReplicaMinimizableDirector class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_REPLICAMINIMIZABLEDIRECTOR_H__DC6C671B_9506_4523_87DC_9FD277D02A3F__INCLUDED_)
#define AFX_REPLICAMINIMIZABLEDIRECTOR_H__DC6C671B_9506_4523_87DC_9FD277D02A3F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\NetworkMinimizableDirector.h"

// this minimizable is only able to treat replicas two at a time 

class CReplicaMinimizableDirector : public NetworkMinimizableDirector  
{
public:
	CReplicaMinimizableDirector(double epsSq = 0.1, double deltaSq = 0.1);
	virtual ~CReplicaMinimizableDirector();
	// returns the sum of GetNParameters() for both the replicas
	int GetNParameters();
	// returns the appropriate residuals
	double ComputeResiduals(double *parameters);
	// returns the appropriate parameter
	double GetParameter(int parIndex);
	// sets up the appropriate intesection lists for the two replicas
	void SetIntersectionLists();
private:
	virtual void DefineExperiments() = 0;
protected:
	intVector m_viIntersectOne;
	intVector m_viIntersectTwo;
	double m_dEpsSquared;
	double m_dDeltaSquared;
};

#endif // !defined(AFX_REPLICAMINIMIZABLEDIRECTOR_H__DC6C671B_9506_4523_87DC_9FD277D02A3F__INCLUDED_)
