// RunDirector.cpp: implementation of the CRunDirector class.
//
//////////////////////////////////////////////////////////////////////

#include "RunDirector.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRunDirector::CRunDirector()
{

}

CRunDirector::~CRunDirector()
{
	// delete the runnables
	for(int i = 0; i < m_vpRunnables.size(); i++)
	{
		delete m_vpRunnables[i];
	}
	// delete the movers
	for(i = 0; i < m_vpRxnMovers.size(); i++)
	{
		delete m_vpRxnMovers[i];
	}
	// delete the cell observers
	for(i = 0; i < m_vpCellObservers.size(); i++)
	{
		delete m_vpCellObservers[i];
	}
	// delete the networks
	for(i = 0; i < m_vpRxnNetworks.size(); i++)
	{
		delete m_vpRxnNetworks[i];
	}
}

void CRunDirector::Execute()
{
	// run all the runnables
	for(int i = 0; i < m_vpRunnables.size(); i++)
	{
		m_vpRunnables[i]->Run();
	}
}
