// Runnable.h: interface for the CRunnable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_RUNNABLE_H__69B67157_9078_4473_9EF4_79E2423C5F7E__INCLUDED_)
#define AFX_RUNNABLE_H__69B67157_9078_4473_9EF4_79E2423C5F7E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../src/ReactionNetwork.h"
#include "../src/ReactionMover.h"
#include "../src/CellAverageObserver.h"
#include "../src/SubjectObserver.h"

class CRunnable  : public Subject
{
public:
	CRunnable();
	virtual ~CRunnable();
	void SetComponents(ReactionNetwork *pRxnNetwork, CReactionMover *pRxnMover, CellAverageObserver *pCellObserver);
	void Run();
	void SetRunnableName(std::string name);
	CellAverageObserver *GetCellObserver() {return m_pCellObserver;}
	ReactionNetwork *GetReactionNetwork() {return m_pRxnNetwork;}
	CReactionMover *GetReactionMover() {return m_pRxnMover;}
	std::string GetRunnableName() const {return m_sRunnableName;}
private:
	ReactionNetwork *m_pRxnNetwork;
	CReactionMover *m_pRxnMover;
	CellAverageObserver *m_pCellObserver;
	std::string m_sRunnableName;
};

#endif // !defined(AFX_RUNNABLE_H__69B67157_9078_4473_9EF4_79E2423C5F7E__INCLUDED_)
