// ScaleInvariantMarquardtMinimizer.h: interface for the CScaleInvariantMarquardtMinimizer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SCALEINVARIANTMARQUARDTMINIMIZER_H__F5D8F7C8_A673_4214_AA46_C9B411DE454A__INCLUDED_)
#define AFX_SCALEINVARIANTMARQUARDTMINIMIZER_H__F5D8F7C8_A673_4214_AA46_C9B411DE454A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../src/LevenbergMarquardtMinimizer.h"
#include "../src/MatrixOperations.h"


class CScaleInvariantMarquardtMinimizer : public CLevenbergMarquardtMinimizer  
{
public:
	CScaleInvariantMarquardtMinimizer();
	CScaleInvariantMarquardtMinimizer(CParameterFilter *pFilter, bool psdFlag, double marquardt, bool checkChi, double chiTol, bool checkGrad, double gradTol, bool checkPar, double parTol, int nIterations, double funcAccuracy);
	virtual ~CScaleInvariantMarquardtMinimizer();
	double Minimize(double *parameters, Minimizable *minimizable);
	// Solve LM system using Singular Value Decomp.
	void SVDSolveMarquardtSystem(double *deltaP);
private:
	bool m_bChiSqFlag;				// Set to true for convergence on chi-squared
	bool m_bGradFlag;				// Set to true for convergence on ||g||
	bool m_bParFlag;                // Set to true for convergence on parameters
};

#endif // !defined(AFX_SCALEINVARIANTMARQUARDTMINIMIZER_H__F5D8F7C8_A673_4214_AA46_C9B411DE454A__INCLUDED_)
