// SingleNetworkRateConstantMinimizable.h: interface for the CSingleNetworkRateConstantMinimizable class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SINGLENETWORKRATECONSTANTMINIMIZABLE_H__3CB44F9C_5033_4553_B845_10127DE5EDFB__INCLUDED_)
#define AFX_SINGLENETWORKRATECONSTANTMINIMIZABLE_H__3CB44F9C_5033_4553_B845_10127DE5EDFB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <iomanip.h>
#include <cmath>
#include <assert.h>
#include "SubjectObserver.h"
#include "NLLSMinimizable.h"
#include "Experiment.h"
#include "ReactionMover.h"
#include "CellAverageObserver.h"
#include "ConversionFactor.h"
#include "..\SRC\NLLSMinimizable.h"
#include "..\SRC\SubjectObserver.h"

class CSingleNetworkRateConstantMinimizable : public NLLSMinimizable, public Subject
{
public:
	CSingleNetworkRateConstantMinimizable();
	CSingleNetworkRateConstantMinimizable(Experiment *pExperiment, CReactionMover *pReactionMover,bool logsInObjectiveFunction, double timeSeriesWeight, double rateConstantsWeight, int nCells=1);
	virtual ~CSingleNetworkRateConstantMinimizable();
	void Initialize(Experiment *pExperiment, CReactionMover *pReactionMover, bool logsInObjectiveFunction, double timeSeriesWeight, double rateConstantsWeight, int nCells);
	Experiment *GetExperiment() {return m_pExperiment;}
	CellAverageObserver *GetCellObserver() {return m_pCellObserver;}
	int GetNCells() {return m_iNCells;} 
	bool GetLogsInObjectiveFunction() const {return m_bLogsInObjectiveFunction;}
	double GetTimeSeriesWeight() const {return m_dTimeSeriesWeight;}
	double GetRateConstantsWeight() const {return m_dRateConstantsWeight;}
	void SetTimeSeriesWeight(double timeSeriesWeight) {m_dTimeSeriesWeight = timeSeriesWeight;}
	void SetRateConstantsWeight(double rateConstantsWeight) {m_dRateConstantsWeight = rateConstantsWeight;}
	double GetParameter(int parIndex);
	// overloaded from base classes
	int GetNParameters();
	double ComputeResiduals(double *parameters);
	CConversionFactor *GetConversionFactor(int factorIndex) {return m_pConversionFactors[factorIndex];} 
private:
	bool m_bLogsInObjectiveFunction;
	Experiment *m_pExperiment;
	CReactionMover *m_pReactionMover;
	CellAverageObserver *m_pCellObserver;
	int m_iNCells;
	double m_dTimeSeriesWeight;
	double m_dRateConstantsWeight;
	double *m_pdInitialNetworkData;
	double *m_pdCurrentNetworkData;
	std::vector<CConversionFactor *> m_pConversionFactors;
}
};

#endif // !defined(AFX_SINGLENETWORKRATECONSTANTMINIMIZABLE_H__3CB44F9C_5033_4553_B845_10127DE5EDFB__INCLUDED_)
