// SparseMatrix.h: interface for the SparseMatrix class.
//	A base class for dealing with sparse matrices; various derived
// classes would implement different storage methods
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SPARSEMATRIX_H__65CE724D_CA90_446E_9082_10C6730DF238__INCLUDED_)
#define AFX_SPARSEMATRIX_H__65CE724D_CA90_446E_9082_10C6730DF238__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class SparseMatrix  
{
public:
	SparseMatrix(int nRows, int nCols);
	virtual void OrderElements() = 0;
	// returns false if an element cannot be added
	virtual bool AddElement(int row, int col, int value) = 0;
	// result of this multiplication is returned in colVector itself
	// function returns false if nCols(matrix) != length
	virtual bool RightVectorMultiply(double *colVector, int length) = 0;
	virtual ~SparseMatrix();
protected:
	int nRows,nCols;
};

#endif // !defined(AFX_SPARSEMATRIX_H__65CE724D_CA90_446E_9082_10C6730DF238__INCLUDED_)
