// SynchronizedRungeKuttaMover.h: interface for the CSynchronizedRungeKuttaMover class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SYNCHRONIZEDRUNGEKUTTAMOVER_H__754789DA_684D_4547_A7A2_6A84EEE85BA6__INCLUDED_)
#define AFX_SYNCHRONIZEDRUNGEKUTTAMOVER_H__754789DA_684D_4547_A7A2_6A84EEE85BA6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC\QualityControlRungeKuttaMover.h"

class CSynchronizedRungeKuttaMover : public CQualityControlRungeKuttaMover  
{
public:
	CSynchronizedRungeKuttaMover(double frequency, double stepsize, double eps=1.0e-05);
	virtual ~CSynchronizedRungeKuttaMover();
	virtual void Move(double xInitial, double xFinal, ReactionNetwork *pReactionNetwork);
private:
	std::vector<double> m_vdSteps;
	bool m_bSyncFlag;
};

#endif // !defined(AFX_SYNCHRONIZEDRUNGEKUTTAMOVER_H__754789DA_684D_4547_A7A2_6A84EEE85BA6__INCLUDED_)
