// VariableStepsizeAnnealMinimizer.h: interface for the CVariableStepsizeAnnealMinimizer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VARIABLESTEPSIZEANNEALMINIMIZER_H__488D7959_852C_425D_A56C_F7357CD77BE2__INCLUDED_)
#define AFX_VARIABLESTEPSIZEANNEALMINIMIZER_H__488D7959_852C_425D_A56C_F7357CD77BE2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "..\SRC_TEMP\SimulatedAnnealingStrategy.h"

class CVariableStepsizeAnnealMinimizer : public CSimulatedAnnealingStrategy  
{
public:
	CVariableStepsizeAnnealMinimizer(int RNGSeed, CParameterFilter *pFilter, double T0=2, double lambda=0.7, double deltaX=1.0,double c=10);
	virtual ~CVariableStepsizeAnnealMinimizer();
	virtual bool AcceptMove(double Eold, double Enew);
	virtual bool Terminate();
	virtual bool Equilibrated();
	virtual void Cool();
	virtual void InitializeTemperature(Minimizable *minimizable);
	virtual void GenerateMove();
private:
	// number of cycles to perform at a particular temperature
	int m_iNMCSteps;
	// factor for the cooling schedule
	double m_dLambda;
	// need the current energy for this method
	double m_dECurrent;
	// stepsize control
	double m_dC;
	// minimum std. dev. for stepsize
	double m_dDeltaX;
	// needed for detailed balance correction
	double m_dSqrLogParDiff;
};

#endif // !defined(AFX_VARIABLESTEPSIZEANNEALMINIMIZER_H__488D7959_852C_425D_A56C_F7357CD77BE2__INCLUDED_)
